# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys, os, time, gtk
import Conf__

#-------------------------------------------------------------------
LIST_KEYBOARD_SHORTCUT = {
	# select next tab.
	# 다음 탭으로 이동
	"keyboard-shortcut-next-tab" : ("<Control>Page_Up" , "self.ac_next_tab "),
	# select previous tab
	# 이전 탭으로 이동
	"keyboard-shortcut-prev-tab" : ("<Control>Page_Down" , "self.ac_previous_tab"),

	# increase font size.
	# vim과 터미널에서 폰트 크기 늘임
	"keyboard-shortcut-increase-font" : ("<Control>equal" , "self.ac_font_increase "),

	# decrease font size.
	# vim과 터미널에서 폰트 크기 줄임
	"keyboard-shortcut-decrease-font" : ("<Control>minus" , "self.ac_font_decrease "),

	# open gvim as new tab
	# gvim을 새로운 탭으로 띄우기
	"keyboard-shortcut-insert-gvim" : ("<Control><Shift>G" , "self.ac_insert_gvim "),

	# open vim as new tab
	# vim을 새로운 탭으로 띄우기
	"keyboard-shortcut-insert-vim" : ("<Control><Shift>V" , "self.ac_insert_vim "),

	# open terminal as new tab
	# 터미널을 새로운 탭으로 띄우기
	"keyboard-shortcut-insert-terminal" : ("<Control><Shift>Z" , "self.ac_insert_terminal "),

	# open external command dialog
	# 외부명령어 입력창 띄우기
	"keyboard-shortcut-run-external-command-dialog" : \
		("<Control><Shift>C" , "self.ac_run_on_external_command"),

	# set focus in the external command text entry in toolbar
	# 외부명령어 입력란에 포커스 이동하기
	"keyboard-shortcut-focus-external-command-entry" : \
		("<Control><Shift>L" , "self.ac_focus_on_external_command"),

	# open file selection dialog
	# 파일 열기
	"keyboard-shortcut-fileselect-dialog" : ("<Alt><Shift>F" , "self.ac_fileSelectionDialog "),

	# quit vee
	# 프로그램 종료
	"keyboard-shortcut-mainwindow-quit" : ("<Control>Q" , "self.on_quit_all"),

	# select tab
	# 숫자키와 함께 사용할 탭 이동 키
	"keyboard-shortcut-modifier-switch-tab" : ("<Alt>%d", "self.ac_change_nth_tab"),

	# show/hide bookmark panel
	# 북마크 패널을 보이고 감추는 키
	"keyboard-shortcut-toggle-bookmark-panel" : ("<Ctrl><Alt>b", "self.ac_toggle_bookmark"),

	# show tab list
	# 탭 목록을 보여주는 키.
	"keyboard-shortcut-show-tab-list" : ("<Shift><Alt>l", "self.ac_show_tab_list"),

	# full screen window
	"keyboard-shortcut-toggle-full-screen" : ("F11", "self.ac_toggle_full_screen"),

}

# Keyboard shortcut
KEYBOARD_SHORTCUT_GLOBAL = ( \
	"keyboard-shortcut-focus-external-command-entry",
	"keyboard-shortcut-toggle-bookmark-panel",
	"keyboard-shortcut-show-tab-list",
	"keyboard-shortcut-run-external-command-dialog",
	"keyboard-shortcut-next-tab",
	"keyboard-shortcut-prev-tab",
	"keyboard-shortcut-increase-font",
	"keyboard-shortcut-decrease-font",
	"keyboard-shortcut-insert-gvim",
	"keyboard-shortcut-insert-vim",
	"keyboard-shortcut-insert-terminal",
	"keyboard-shortcut-fileselect-dialog",
	"keyboard-shortcut-mainwindow-quit",
	"keyboard-shortcut-toggle-full-screen",
)

KEYBOARD_SHORTCUT_LIST_FOR_TREEVIEW = { \
	"Insert Module" : ( \
		("keyboard-shortcut-insert-vim", "Run VIM", ), \
		("keyboard-shortcut-insert-gvim", "Run GVIM", ), \
		("keyboard-shortcut-insert-terminal", "Run Terminal", ), \
	), \
	"VEE Management" : ( \
		("keyboard-shortcut-mainwindow-quit", "Quit VEE", ), \
		#("keyboard-shortcut-modifier-switch-tab", "Switch between tabs", ), \
		("keyboard-shortcut-show-tab-list", "Show tab list", ), \
		("keyboard-shortcut-toggle-bookmark-panel", "Toggle bookmark panel", ), \
		("keyboard-shortcut-toggle-full-screen", "Toggle fullscreen", ), \
		("keyboard-shortcut-next-tab", "Go next tab", ), \
		("keyboard-shortcut-prev-tab", "Go previous tab", ), \
		("keyboard-shortcut-run-external-command-dialog", \
			"Run the external command dialog", ), \
		("keyboard-shortcut-fileselect-dialog", \
			"Run the file/directory chooser dialog", ), \
		("keyboard-shortcut-increase-font", "Increase font size", ), \
		("keyboard-shortcut-decrease-font", "Decrease font size", ), \
		("keyboard-shortcut-focus-external-command-entry", \
			"Focus in the external command entry", ), \
	),
}

#-------------------------------------------------------------------
# D&D
DND_TARGET_COLOR = 100
DND_TARGET_BGIMAGE = 101
DND_TARGET_RESET_BG = 102
DND_TARGET_URI_LIST = 103
DND_TARGET_MOZ_URL = 104
DND_TARGET_UTF8_STRING = 105
DND_TARGET_COMPOUND_TEXT = 106
DND_TARGET_TEXT_PLAIN = 107
DND_TARGET_STRING = 108
DND_TARGET_TEXT_PLAIN = 109
DND_TARGET_TEXT = 110

# drag and drop target tables, it from terminal-screen.c in
# gnome-terminal.
DND_TARGET_TABLE = [
	( "application/x-color", 0, DND_TARGET_COLOR ),
	( "property/bgimage",    0, DND_TARGET_BGIMAGE ),
	( "x-special/gnome-reset-background", 0, DND_TARGET_RESET_BG ),
	( "text/uri-list",  0, DND_TARGET_URI_LIST ),
	( "text/x-moz-url",  0, DND_TARGET_MOZ_URL ),
	( "UTF8_STRING", 0, DND_TARGET_UTF8_STRING ),
	( "COMPOUND_TEXT", 0, DND_TARGET_COMPOUND_TEXT ),
	( "TEXT", 0, DND_TARGET_TEXT ),
	( "STRING",     0, DND_TARGET_STRING ),
	( "text/plain", 0, DND_TARGET_TEXT_PLAIN )
]

#-------------------------------------------------------------------
# GConf
# GLOBAL configuration values.
GLOBAL_FONT_SYSTEM_DEFAULT		= "/desktop/gnome/interface/monospace_font_name"

# LOCAL configuration values.
LOCAL_ROOT									=	"/apps/vee/"
SCHEMA_ROOT									=	"/schemas/apps/vee/"
SCHEMA_FILE									=	\
	os.path.join(Conf__.DIR_LIBFILE, "vee.schema")

SCHEMA = {
	"use-system-default-font" : {
		"key" : LOCAL_ROOT + "use_system_default_font",
		"schema" : SCHEMA_ROOT + "use_system_default_font",
		"type" : "bool",
		"default" : True,
	},

	"font" : {
		"key" : LOCAL_ROOT + "font",
		"schema" : SCHEMA_ROOT + "font",
		"type" : "string",
		"default" : "Monospace 16",
	},

	"show-menubar" : {
		"key" : LOCAL_ROOT + "show_menubar",
		"schema" : SCHEMA_ROOT + "show_menubar",
		"type" : "bool",
		"default" : True,
	},

	"show-toolbar" : {
		"key" : LOCAL_ROOT + "show_toolbar",
		"schema" : SCHEMA_ROOT + "show_toolbar",
		"type" : "bool",
		"default" : True,
	},

	"show-statusbar" : {
		"key" : LOCAL_ROOT + "show_statusbar",
		"schema" : SCHEMA_ROOT + "show_statusbar",
		"type" : "bool",
		"default" : True,
	},

	"show-bookmark" : {
		"key" : LOCAL_ROOT + "show_bookmark",
		"schema" : SCHEMA_ROOT + "show_bookmark",
		"type" : "bool",
		"default" : True,
	},

	"command-gvim" : {
		"key" : LOCAL_ROOT + "gvim_command",
		"schema" : SCHEMA_ROOT + "gvim_command",
		"type" : "string",
		"default" : "gvim",
	},

	"command-vim" : {
		"key" : LOCAL_ROOT + "vim_command",
		"schema" : SCHEMA_ROOT + "vim_command",
		"type" : "string",
		"default" : "vim",
	},

	"command-terminal" : {
		"key" : LOCAL_ROOT + "terminal_command",
		"schema" : SCHEMA_ROOT + "terminal_command",
		"type" : "string",
		"default" : "bash",
	},

	"latest-window-geometry" : {
		"key" : LOCAL_ROOT + "latest_window_geometry",
		"schema" : SCHEMA_ROOT + "latest_window_geometry",
		"type" : "string",
		"default" : "700,800,10,10",
	},

	"max-scrollline" : {
		"key" : LOCAL_ROOT + "max_scrollline",
		"schema" : SCHEMA_ROOT + "max_scrollline",
		"type" : "int",
		"default" : 100,
	},

	# filename to insert as new tab in console command.
	"filename-to-insert-as-new-tab-in-vim" : {
		"key" : LOCAL_ROOT + "filename_to_insert_as_new_tab_in_vim",
		"schema" : SCHEMA_ROOT + "filename_to_insert_as_new_tab_in_vim",
		"type" : "string",
		"default" : "",
	},

	"filename-to-insert-as-new-tab-in-gvim" : {
		"key" : LOCAL_ROOT + "filename_to_insert_as_new_tab_in_gvim",
		"schema" : SCHEMA_ROOT + "filename_to_insert_as_new_tab_in_gvim",
		"type" : "string",
		"default" : "",
	},

	"last-directory-path" : {
		"key" : LOCAL_ROOT + "last_directory_path",
		"schema" : SCHEMA_ROOT + "last_directory_path",
		"type" : "string",
		"default" : "/",
	},

	"last-directory-path-in-fileselectdialog" : {
		"key" : LOCAL_ROOT + "last_directory_path_in_fileselectdialog",
		"schema" : SCHEMA_ROOT + "last_directory_path_in_fileselectdialog",
		"type" : "string",
		"default" : "/",
	},

	"external-command-list" : {
		"key" : LOCAL_ROOT + "external_command_list",
		"schema" : SCHEMA_ROOT + "external_command_list",
		"type" : "string",
		"default" : "",
	},

	"color-foreground" : {
		"key" : LOCAL_ROOT + "color_foreground",
		"schema" : SCHEMA_ROOT + "color_foreground",
		"type" : "string",
		"default" : "black",
	},

	"color-background" : {
		"key" : LOCAL_ROOT + "color_background",
		"schema" : SCHEMA_ROOT + "color_background",
		"type" : "string",
		"default" : "white",
	},

	"color-dim" : {
		"key" : LOCAL_ROOT + "color_dim",
		"schema" : SCHEMA_ROOT + "color_dim",
		"type" : "string",
		"default" : "blue",
	},

	"color-highlight" : {
		"key" : LOCAL_ROOT + "color_highlight",
		"schema" : SCHEMA_ROOT + "color_highlight",
		"type" : "string",
		"default" : "green",
	},

	"color-cursor" : {
		"key" : LOCAL_ROOT + "color_cursor",
		"schema" : SCHEMA_ROOT + "color_cursor",
		"type" : "string",
		"default" : "red",
	},

	"recent-opened-files" : {
		"key" : LOCAL_ROOT + "recent_opened_files",
		"schema" : SCHEMA_ROOT + "recent_opened_files",
		"type" : "string",
		"default" : "",
	},

	"recent-opened-directories" : {
		"key" : LOCAL_ROOT + "recent_opened_directories",
		"schema" : SCHEMA_ROOT + "recent_opened_directories",
		"type" : "string",
		"default" : "",
	},

	"tab-position" : {
		"key" : LOCAL_ROOT + "tab_position",
		"schema" : SCHEMA_ROOT + "tab_position",
		"type" : "string",
		"default" : "",
	},

	"use-vim" : {
		"key" : LOCAL_ROOT + "use_vim",
		"schema" : SCHEMA_ROOT + "use_vim",
		"type" : "bool",
		"default" : True,
	},

	"use-gvim" : {
		"key" : LOCAL_ROOT + "use_gvim",
		"schema" : SCHEMA_ROOT + "use_gvim",
		"type" : "bool",
		"default" : True,
	},

	"use-terminal" : {
		"key" : LOCAL_ROOT + "use_terminal",
		"schema" : SCHEMA_ROOT + "use_terminal",
		"type" : "bool",
		"default" : True,
	},

	"is-fullscreen" : {
		"key" : LOCAL_ROOT + "is_fullscreen",
		"schema" : SCHEMA_ROOT + "is_fullscreen",
		"type" : "bool",
		"default" : False,
	},

	"initial-module" : {
		"key" : LOCAL_ROOT + "initial_module",
		"schema" : SCHEMA_ROOT + "initial_module",
		"type" : "string",
		"default" : "None",
	},

	"vte-background-type" : {
		"key" : LOCAL_ROOT + "vte_background_type",
		"schema" : SCHEMA_ROOT + "vte_background_type",
		"type" : "string",
		"default" : "None", # None, transparent, image-file
	},

	"vte-background-image-file" : {
		"key" : LOCAL_ROOT + "vte_background_image_file",
		"schema" : SCHEMA_ROOT + "vte_background_image_file",
		"type" : "string",
		"default" : "",
	},

	"vte-background-shade" : {
		"key" : LOCAL_ROOT + "vte_background_shade",
		"schema" : SCHEMA_ROOT + "vte_background_shade",
		"type" : "float",
		"default" : 0.2,
	},

	"window-title" : {
		"key" : LOCAL_ROOT + "window_title",
		"schema" : SCHEMA_ROOT + "window_title",
		"type" : "string",
		"default" : "%s : VEE",
	},

	# keyboard shortcut keys,
	"keyboard-shortcut-next-tab" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_next_tab",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_next_tab",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-prev-tab" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_prev_tab",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_prev_tab",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-increase-font" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_increase_font",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_increase_font",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-decrease-font" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_decrease_font",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_decrease_font",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-insert-gvim" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_insert_gvim",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_insert_gvim",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-insert-vim" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_insert_vim",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_insert_vim",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-insert-terminal" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_insert_terminal",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_insert_terminal",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-run-external-command-dialog" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_run_external_command_dialog",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_run_external_command_dialog",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-focus-external-command-entry" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_focus_external_command_entry",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_focus_external_command_entry",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-fileselect-dialog" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_fileselect_dialog",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_fileselect_dialog",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-mainwindow-quit" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_mainwindow_quit",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_mainwindow_quit",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-modifier-switch-tab" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_modifier_switch_tab",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_modifier_switch_tab",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-toggle-bookmark-panel" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_toggle_bookmark_panel",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_toggle_bookmark_panel",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-show-tab-list" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_show_tab_list",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_show_tab_list",
		"type" : "string",
		"default" : "",
	},

	"keyboard-shortcut-toggle-full-screen" : {
		"key" : LOCAL_ROOT + "keyboard_shortcut_toggle_full_screen",
		"schema" : SCHEMA_ROOT + "keyboard_shortcut_toggle_full_screen",
		"type" : "string",
		"default" : "",
	},


}

# the number of characters in label.
LABEL_LENGTH = 20

# GTK MODIFIER MASK list
NULL_MODIFIER_MASK = 0

AVAILABLE_MODIFIER_MASK = \
	gtk.gdk.SHIFT_MASK | \
	gtk.gdk.LOCK_MASK | \
	gtk.gdk.CONTROL_MASK | \
	gtk.gdk.MOD1_MASK | \
	gtk.gdk.MOD2_MASK | \
	gtk.gdk.MOD3_MASK | \
	gtk.gdk.MOD4_MASK | \
	gtk.gdk.MOD5_MASK
	#gtk.gdk.BUTTON1_MASK | \
	#gtk.gdk.BUTTON2_MASK | \
	#gtk.gdk.BUTTON3_MASK | \
	#gtk.gdk.BUTTON4_MASK | \
	#gtk.gdk.BUTTON5_MASK | \
	#gtk.gdk.RELEASE_MASK | \
	#gtk.gdk.MODIFIER_MASK

UPPER_SYMBOLS = { \
	"exclam" : "1", \
	"numbersign" : "3", \
	"percent" : "5", \
	"asciicircum" : "6", \
	"plus" : "equal", \
	"braceleft" : "bracketleft", \
	"colon" : "semicolon", \
	"quotedbl" : "apostrophe", \
	"asciitilde" : "grave", \
	"bar" : "backslash", \
	"less" : "comma", \
	"greater" : "period", \
	"question" : "slash", \
	"dollar" : "4", \
	"Control_backslash" : "4", \
	"at" : "2", \
	"nul" : "2", \
	"ampersand" : "7", \
	"braceleft" : "7", \
	"Control_underscore" : "7", \
	"asterisk" : "8", \
	"bracketleft" : "8", \
	"Delete" : "8", \
	"parenleft" : "9", \
	"bracketright" : "9", \
	"parenright" : "0", \
	"braceright" : "0", \
	"underscore" : "minus", \
	"backslash" : "minus", \
	"Control_underscore" : "minus", \
	"Control_underscore" : "minus", \
	"braceright" : "bracketright", \
	"asciitilde" : "bracketright", \
	"Control_bracketright" : "bracketright", \
	"greater" : "less", \
	"bar" : "less", \
}

BOOKMARK_FILE = os.path.join( \
	os.getenv("HOME"), Conf__.DIR_LOCAL, "bookmark.xml")

BOOKMARK_ITEM_DATA = { \
	"__uid__" : "str", \
	"__parent__" : "str", \
	"label" : "str", \
	"type" : "str", \
	"value" : "str", \
	"command" : "str", \
	"use_system_default_font" : "bool", \
	"font" : "str", \
	"color_foreground" : "str", \
	"color_background" : "str", \
	"color_dim" : "str", \
	"color_highlight" : "str", \
	"color_cursor" : "str", \
	"max_scroll_line" : "int", \
	"vte_background_shade" : "float", \
	"vte_background_type" : "str", \
	"vte_background_image_file" : "str", \
}

BOOKMARK_ITEM_DATA_SKEL = { \
	"__uid__" : str(), \
	"__parent__" : str(), \
	"label" : str(), \
	"type" : str(), \
	"value" : str(), \
	"command" : str(), \
	"use_system_default_font" : bool(), \
	"font" : str(), \
	"color_foreground" : str(), \
	"color_background" : str(), \
	"color_dim" : str(), \
	"color_highlight" : str(), \
	"color_cursor" : str(), \
	"max_scroll_line" : str(), \
	"vte_background_shade" : float(), \
	"vte_background_type" : str(), \
	"vte_background_image_file" : str(), \
}

BOOKMARK_ITEM_NO_PARENT = "-100"

BOOKMARK_ITEM_SETTING = (
	"command", \
	"use_system_default_font", \
	"font", \
	"color_foreground", \
	"color_background", \
	"color_dim", \
	"color_highlight", \
	"color_cursor", \
	"max_scroll_line", \
	"vte_background_shade", \
	"vte_background_type", \
	"vte_background_image_file", \
)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Conf.py"


