# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
import gtk, gobject, base64, marshal, gnome

import TAB, WIDGET, Label, State, \
	Dialog, GConf, Conf, Conf__, Menu, child, \
	func, Panel, Handler, Accel, BookmarkItem

import i18n
_ = i18n.gettext()

class VEE (WIDGET.WIDGET) :

	UID = None

	LIST_TAB = None
	NOTEBOOK = None
	BOOKMARKS = None

	STATE = None
	IS_LOGO = True

	Toolbar = None
	Menubar = None

	ARGS_OPTIONS = dict()
	ARGS_ARGS = list()

	ENTRY_EXTERNAL_COMMAND = None
	LISTSTORE_EXTERNAL_COMMAND = None

	LIST_TAB_SHORTCUT = dict()

	ID_EVENT_SOURCE = None

	HISTORY_TAB = list()

	IS_FULLSCREEN = False
	HIDE_WIDGET_CAUSED_BY_FULLSCREEN = list()

	def __init__ (self, **kwargs) :

		# parse arguments and options.
		if kwargs.has_key("args_options") :
			self.ARGS_OPTIONS = kwargs["args_options"]

		if kwargs.has_key("args_args") :
			self.ARGS_ARGS = kwargs["args_args"]

		# check environment.

		# whether local directory, ~/.gnome/vee.
		__BOOKMARK_FILE = Conf.BOOKMARK_FILE
		if not os.path.isdir(os.path.dirname(Conf.BOOKMARK_FILE)) :
			try :
				os.makedirs(os.path.dirname(Conf.BOOKMARK_FILE))
			except OSError :
				__BOOKMARK_FILE = \
					os.path.join(os.getenv("HOME"), "vee_bookmark.xml")

		# store data in STATE.
		self.STATE = State.State()

		# set uid.
		self.UID = os.getpid()
		self.STATE.set_value("uid", self.UID)
		self.HISTORY_TAB = TAB.History()
		self.STATE.set_value("tab-history", self.HISTORY_TAB)
		self.LIST_TAB = TAB.List()
		self.STATE.set_value("tab-list", self.LIST_TAB)

		self.STATE.set_value("toggled-statusbar", not self.ARGS_OPTIONS.ARG_SHOW_STATUSBAR)
		self.STATE.set_value("toggled-toolbar", not self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR)
		self.STATE.set_value("toggled-menubar", not self.ARGS_OPTIONS.ARG_SHOW_MENUBAR)
		self.STATE.set_value("toggled-bookmark", not self.ARGS_OPTIONS.ARG_SHOW_BOOKMARK)

		# set bookmark
		self.BOOKMARKS = BookmarkItem.Them()
		self.BOOKMARKS.__import__(__BOOKMARK_FILE)
		self.STATE.set_value("bookmark", self.BOOKMARKS)

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.set_path(Conf.LOCAL_ROOT)
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		"""
		WARNING :
			I don't know why the "gnome.program_init()" be required here,
			but without it VEE cause this error,
			---------------------------------------------------
			GnomeUI-ERROR **: You must call gnome_program_init() before
			creating a GnomeApp
			aborting...
			Aborted
			---------------------------------------------------
		"""
		try :
			gnome.program_init("VEE","VEE")
		except :
			pass

		WIDGET.WIDGET.__init__(self, "vee", None, dict(), Handler.MAIN_WINDOW)

		self.STATE.set_value("root-widget", self.WIDGET_SELF)

		self.WIDGET_SELF.set_title(_("vee"))

		__callback_functions = {"addPage" : self.addPage}

		##############################################################
		# ACCELERATORS

		import Accel
		self.AccelGrpGlobal = \
			self.install_accel_group(Conf.KEYBOARD_SHORTCUT_GLOBAL)

		##############################################################
		# set event
		self.WIDGET_SELF.set_events(gtk.gdk.KEY_RELEASE)

		EventBox_Notebook = self.xml.get_widget("eventbox1")
		EventBox_Notebook.connect("event", self.on_show_logo)
		EventBox_Notebook.connect( \
			"key-release-event", self.on_prevent_key_intercept)

		# add notification using GConf.
		gconf_notify = GConf.Notify( \
			callback_functions=__callback_functions, \
			state=self.STATE \
		)
		gconf_notify.add()

		##################################################################
		# set the widget initializing.

		# status bar
		self.Statusbar = self.xml.get_widget("statusbar1")
		STATUSBAR = Label.Statusbar(self.Statusbar)
		STATUSBAR.clean()
		self.STATE.set_value("statusbar", STATUSBAR)

		# toolbar and menubar
		self.Toolbar = self.xml.get_widget("toolbar1")
		self.Menubar = self.xml.get_widget("hbox1")
		self.STATE.set_value("toolbar", self.Toolbar)
		self.STATE.set_value("menubar", self.Menubar)

		# set toolbar and menubar.
		notify_id = self.GCONF_CLIENT.CLIENT.notify_add( \
			"/desktop/gnome/interface/toolbar_style", \
			self.nf_toolbar_style)
		self.__set_toolbar_style()

		notify_id = self.GCONF_CLIENT.CLIENT.notify_add( \
			"/desktop/gnome/interface/toolbar_icon_size", \
			self.nf_toolbar_icon_size)
		self.__set_toolbar_icon_size()

		if not self.GCONF_CLIENT.get_value_by_conf("show-toolbar") :
			self.Toolbar.hide()

		if not self.GCONF_CLIENT.get_value_by_conf("show-menubar") :
			self.Menubar.hide()

		# set menu label name
		self.__set_menubar()

		# notebook
		self.NOTEBOOK = self.xml.get_widget("notebook1")
		self.STATE.set_value("notebook", self.NOTEBOOK)
		self.NOTEBOOK.connect_after( \
			"switch-page", self.on_notebook_switch_page)
		self.NOTEBOOK.remove_page(0)
		self.NOTEBOOK.popup_disable()

		# set tab position in notebook
		__tab_position =  \
			self.GCONF_CLIENT.get_value_by_conf("tab-position")
		if __tab_position == "Top" :
			__pos = gtk.POS_TOP
		elif __tab_position == "Bottom" :
			__pos = gtk.POS_BOTTOM
		elif __tab_position == "Left" :
			__pos = gtk.POS_LEFT
		elif __tab_position == "Right" :
			__pos = gtk.POS_RIGHT
		else : # default
			__pos = gtk.POS_TOP

		self.NOTEBOOK.set_property("tab-pos", __pos)

		# ACTIVATE dnd.
		self.NOTEBOOK.connect("drag_data_received", self.on_drag_received)
		self.Menubar.connect("drag_data_received", self.on_drag_received)
		self.Toolbar.connect("drag_data_received", self.on_drag_received)

		self.NOTEBOOK.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.Menubar.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.Toolbar.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		# bookmark panel
		self.PANEL_BOOKMARK = self.xml.get_widget("vbox11")
		self.STATE.set_value("panel-bookmark", self.PANEL_BOOKMARK)

		if self.GCONF_CLIENT.get_value_by_conf("show-bookmark") :
			self.PANEL_BOOKMARK.show()
		else :
			self.PANEL_BOOKMARK.hide()

		# connect signal
		self.PANEL_BOOKMARK.connect("show", self.on_notify_bookmark)
		self.PANEL_BOOKMARK.connect("hide", self.on_notify_bookmark)

		# external command entry.
		ENTRY_EXTERNAL_COMMAND = \
			self.xml.get_widget("comboboxentry2").child
		ENTRY_EXTERNAL_COMMAND.connect("activate", self.on_external_command)
		__completion = gtk.EntryCompletion()
		ENTRY_EXTERNAL_COMMAND.set_completion(__completion)
		self.LISTSTORE_EXTERNAL_COMMAND = gtk.ListStore(gobject.TYPE_STRING)
		__completion.set_model(self.LISTSTORE_EXTERNAL_COMMAND)
		__completion.set_text_column(0)

		# activate popup menu
		self.NOTEBOOK.connect( \
			"button-press-event", \
			Menu.on_show_popup_full, \
			self.WIDGET_SELF, \
			self.STATE, \
			__callback_functions, \
			self.LISTSTORE_EXTERNAL_COMMAND \
		)

		# settting for toolbutton.
		__button_gvim = self.xml.get_widget("toolbutton12")

		# hide new window toolbutton.
		__button_vim = self.xml.get_widget("toolbutton1")
		__button_terminal = self.xml.get_widget("toolbutton8")
		__openfile_button = self.xml.get_widget("toolbutton5")
		__next_tab_button = self.xml.get_widget("toolbutton9")
		__prev_tab_button = self.xml.get_widget("toolbutton10")
		__command_label = self.xml.get_widget("toolbutton14")

		# connect signal for toolbutton.
		__button_vim.connect( \
			"drag_data_received", self.on_drag_received_button_vim)
		__button_vim.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		__button_gvim.connect( \
			"drag_data_received", self.on_drag_received_button_gvim)
		__button_gvim.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		__button_terminal.connect( \
			"drag_data_received", self.on_drag_received_button_terminal)
		__button_terminal.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		# whether child's buttons set visible or not.
		__command_gvim = \
			self.GCONF_CLIENT.get_value_by_conf("command-gvim")

		self.STATE.set_value("vim-button", __button_vim)
		self.STATE.set_value("gvim-button", __button_gvim)
		self.STATE.set_value("terminal-button", __button_terminal)
		if len(__command_gvim.strip()) < 1 :
			__button_gvim.hide()

		for __childname in ("vim", "gvim", "terminal") :
			if not self.GCONF_CLIENT.get_value_by_conf( \
					"use-%s" % __childname) :
				self.STATE.get_value("%s-button" % __childname).hide()

		# set label of toolbutton
		for i, j in i18n.LABEL_MAIN_WINDOW.items() :
			self.xml.get_widget(i).set_label(j)

		self.on_notify_bookmark()

		# creating Bookmarks
		self.Bookmarks = Panel.Bookmarks( \
			self.xml, \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

		"""
		Notice:
			To fake the gtk.Window.move() method, create a dummy gtk
			window and immediately destroy it, and then the problem,
			which can not set the main focus to main window when the move
			method called, was resolved.
		"""
		__dummy_window = gtk.Window()
		__dummy_window.realize()

		if self.PANEL_BOOKMARK.get_property("visible") and \
				len(self.LIST_TAB) < 1 :
			bookmark_tree = self.xml.get_widget("treeview2")
			bookmark_tree.grab_focus()

		self.WIDGET_SELF.set_resize_mode(gtk.RESIZE_PARENT)

		self.__set_geometry()
		__dummy_window.destroy()

		if not self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR : self.Toolbar.hide()
		if not self.ARGS_OPTIONS.ARG_SHOW_MENUBAR : self.Menubar.hide()
		if not self.ARGS_OPTIONS.ARG_SHOW_STATUSBAR : self.Statusbar.hide()
		if not self.ARGS_OPTIONS.ARG_SHOW_BOOKMARK :
			self.PANEL_BOOKMARK.hide()
		else :
			self.PANEL_BOOKMARK.show()

		# set fullscreen menu label.
		self.__set_fullscreen_label()

		##############################################################
		# apply command line argument options.
		if len(self.ARGS_ARGS) > 0 :
			for i in self.ARGS_ARGS :
				self.addPage("vim", filename=i)
		else :
			if self.ARGS_OPTIONS.ARG_START_WITH_VIM :
				self.addPage("vim")
			if self.ARGS_OPTIONS.ARG_START_WITH_TERMINAL :
				self.addPage("terminal")

			__initial_module = self.GCONF_CLIENT.get_value_by_conf("initial-module")
			if not self.ARGS_OPTIONS.ARG_START_WITH_VIM and \
					not self.ARGS_OPTIONS.ARG_START_WITH_TERMINAL and \
					__initial_module != "None" :
				self.addPage(__initial_module)

	# EVENT HANDLER #####################################################
	def on_prevent_key_intercept (self, parm1, parm2) :
		__n = self.NOTEBOOK.get_current_page()
		try :
			self.LIST_TAB.get_child_widget(__n).grab_focus()
		except :
			pass

	def on_notebook_switch_page (self, widget, parm1, parm2) :
		if len(self.LIST_TAB) < 1 : return

		# change window title.
		current_page = self.NOTEBOOK.get_current_page()
		try :
			__title = self.LIST_TAB.get_child(current_page).get_title()
		except IndexError :
			return
		else :
			__child_type = self.LIST_TAB.get_child(current_page).CHILD_TYPE

			if __child_type in (child.TYPE_TERMINAL, child.TYPE_VIM) :
				isFilepath = True
			else :
				isFilepath = False

			WIDGET.set_title(self.WIDGET_SELF, self.GCONF_CLIENT, __title, isFilepath)

		self.HISTORY_TAB.add(current_page)

	def on_drag_received_button_vim \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("vim", filename=__path)

	def on_drag_received_button_gvim \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("gvim", filename=__path)

	def on_drag_received_button_terminal \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("terminal", directory=__path)

	def on_drag_received \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("vim", filename=__path)

	def on_quit_all \
			(self, parm1, parm2=None, parm3=None, parm4=None) :
		Dialog.AskCloseAllTabDialog(self.WIDGET_SELF, self.STATE)

		return True

	def on_external_command_dialog (self, widget) :
		__callback_functions = {"addPage" : self.addPage}
		ExternalCommand( \
			state=self.STATE, \
			callback_functions=__callback_functions, \
			completion_liststore=self.LISTSTORE_EXTERNAL_COMMAND \
		)

	def on_external_command (self, widget) :
		__c = widget.get_text()
		if len(__c.strip()) < 1 : return

		parsed_argv = func.parse_command_line_argument(__c)

		if len(parsed_argv["command"].strip()) < 1 : return

		if not func.is_valid_command(parsed_argv["command"]) :
			NoValidCommand(parsed_argv["command"])
			return

		self.LISTSTORE_EXTERNAL_COMMAND.append([__c, ])
		self.addPage("external_command", external_command=__c.strip())

		# make this be blank.
		widget.set_text("")

	def __window_size_changed (self, widget, requisition) :
		# Do not remember the window size when window was fullscreened.
		if self.IS_FULLSCREEN : return

		"""
		NOTICE :
			requisition is gtk.Requisition and requisition has two
			properties, width and height, but it does not tell the real
			window size, so use gtk.Window.get_size() method.
		"""
		self.WIDGET_SELF.set_data("window-size", self.WIDGET_SELF.get_size())

	def on_toggle_menubar (self, widget) :
		if self.Menubar.get_property("visible") :
			self.Menubar.hide()
		else :
			self.Menubar.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-menubar")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child()

	def on_toggle_toolbar (self, widget) :
		if self.Toolbar.get_property("visible") :
			self.Toolbar.hide()
		else :
			self.Toolbar.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-toolbar")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child()

	def on_toggle_statusbar (self, widget) :
		if self.Statusbar.get_property("visible") :
			self.Statusbar.hide()
		else :
			self.Statusbar.show()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-statusbar")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		self.reset_child()

	def on_notify_bookmark (self, widget=None) :
		__label = self.xml.get_widget("label93")
		if self.PANEL_BOOKMARK.get_property("visible") :
			__label.set_label(_("Hide Bookmark Panel (Ctrl+Alt+B)"))
		else :
			__label.set_label(_("Show Bookmark Panel (Ctrl+Alt+B)"))

	def on_toggle_bookmark (self, widget) :
		self.__toggle_bookmark()

	def on_show_logo (self, parm1, parm2) :
		if self.NOTEBOOK.get_n_pages() < 1 :
			self.addLogo()

	def on_open_file_dialog (self, widget) :
		__callback_functions = {"addPage" : self.addPage}

		Dialog.FileSelectionDialog( \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

	def on_preferences (self, widget) :
		Preferences()

	def on_help (self, widget) :
		__localedir = i18n.getDirectoryLocale(Conf__.DIR_HELP)
		if __localedir is None :
			__localedir = os.path.join(Conf__.DIR_HELP, "en")

		__help_file = os.path.join(__localedir, "vee.xml")

		gnome.help_display_uri("ghelp://%s" % __help_file)

	def on_help_keyboard_shortcut (self, widget) :
		__localedir = i18n.getDirectoryLocale(Conf__.DIR_HELP)
		if __localedir is None :
			__localedir = os.path.join(Conf__.DIR_HELP, "en")

		__help_file = os.path.join(__localedir, "vee.xml")

		gnome.help_display_uri("ghelp://%s#myapp-keyboard-shortcut" % __help_file)

	def on_about (self, widget) :
		About()

	def on_insert_gvim (self, widget) :
		self.addPage("gvim")

	def on_insert_vim (self, widget) :
		self.addPage("vim")

	def on_insert_terminal (self, widget) :
		self.addPage("terminal")

	def on_remove_page (self, widget) :
		__current_page = self.NOTEBOOK.get_current_page()
		tab = self.LIST_TAB.get(__current_page)
		tab.Child.exit()
		STATUSBAR.clean()

	def on_next_tab (self, widget) :
		self.NOTEBOOK.next_page()

	def on_previous_tab (self, widget) :
		self.NOTEBOOK.prev_page()

	def on_show_tab_list (self, widget) :
		if len(self.LIST_TAB) < 2 : return
		TabList(state=self.STATE)

	def on_fullscreen (self, widget) :
		self.__toggle_full_screen()
		self.__set_fullscreen_label()

	#########################################################################
	# NOTIFY handler
	def nf_toolbar_style (self, client, parm1, parm2, parm3) :
		__value = self.GCONF_CLIENT.get_value_from_value(parm2.get_value())
		self.__set_toolbar_style(__value)

	def nf_toolbar_icon_size (self, client, parm1, parm2, parm3) :
		__value = self.GCONF_CLIENT.get_value_from_value(parm2.get_value())
		self.__set_toolbar_icon_size(__value)

	#########################################################################
	# Accel HANDLER
	def ac_toggle_full_screen (self, widget, parm1, parm2, parm3) :
		self.__toggle_full_screen()

	def ac_show_tab_list (self, widget, parm1, parm2, parm3) :
		if len(self.LIST_TAB) < 2 : return
		TabList(state=self.STATE)

	def ac_toggle_bookmark (self, parm1, parm2, parm3, parm4) :
		self.__toggle_bookmark()

	def ac_change_nth_tab (self, parm1, parm2, parm3, parm4) :
		"""
		 - 손경욱(vvs740@nospam@chol.com)님이 보내준 패치를 수정해서 적용
		"""
		self.NOTEBOOK.grab_focus()
		__n = self.LIST_TAB_SHORTCUT[parm3]
		if __n == self.NOTEBOOK.get_current_page() : return

		self.NOTEBOOK.set_current_page(__n)

	def ac_font_decrease (self, parm1, parm2, parm3, parm4) :
		try :
			tab = self.LIST_TAB.get(self.NOTEBOOK.get_current_page())
		except :
			return

		tab.Child.decrease_font()

	def ac_font_increase (self, parm1, parm2, parm3, parm4) :
		try :
			tab = self.LIST_TAB(self.NOTEBOOK.get_current_page())
		except :
			return

		tab.Child.increase_font()

	def ac_insert_gvim (self, parm1, parm2, parm3, parm4) :
		self.addPage("gvim")

	def ac_insert_vim (self, parm1, parm2, parm3, parm4) :
		self.addPage("vim")

	def ac_insert_terminal (self, parm1, parm2, parm3, parm4) :
		self.addPage("terminal")

	def ac_fileSelectionDialog  (self, parm1, parm2, parm3, parm4) :
		__callback_functions = {"addPage" : self.addPage}
		Dialog.FileSelectionDialog( \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

	def ac_next_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.next_page()

	def ac_previous_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.prev_page()

	def ac_run_on_external_command (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.grab_focus()

		__callback_functions = {"addPage" : self.addPage}
		ExternalCommand( \
			state=self.STATE, \
			callback_functions=__callback_functions, \
			completion_liststore=self.LISTSTORE_EXTERNAL_COMMAND \
		)

	def ac_focus_on_external_command (self, parm1, parm2, parm3, parm4) :
		if self.Toolbar.get_property("visible") :
			__entry = self.xml.get_widget("comboboxentry2").child
			__entry.grab_focus()

	#############################################################
	# etc method.
	def __toggle_bookmark (self) :
		self.NOTEBOOK.grab_focus()
		if self.PANEL_BOOKMARK.get_property("visible") :
			self.PANEL_BOOKMARK.hide()
		else :
			self.PANEL_BOOKMARK.show()
			bookmark_tree = self.xml.get_widget("treeview2")
			bookmark_tree.grab_focus()

		cnxid = self.STATE.get_value("gconf-notify-cnxid-bookmark")
		self.GCONF_CLIENT.CLIENT.notify_remove(cnxid)

		# reset terminal
		#self.reset_child()

	def __set_fullscreen_label (self) :
		__menu_item = self.xml.get_widget("fullscreen1")
		if self.IS_FULLSCREEN :
			__menu_item.get_children()[0].set_label(_("Restore window (F11)"))
		else :
			__menu_item.get_children()[0].set_label(_("Fullscreen window (F11)"))

	def __addAccelKeySwitchTab (self) :
		"""
		그놈 터미널이나 에피파니처럼 Alt+숫자키로 탭이동하는 패치.
		 - 손경욱(vvs740@nospam@chol.com)님이 보내준 패치를 수정해서 적용
		"""
		__c = Conf.LIST_KEYBOARD_SHORTCUT["keyboard-shortcut-modifier-switch-tab"]

		num = len(self.LIST_TAB_SHORTCUT)
		__accel_key = __c[0] % (num + 1)
		__key, __mod = gtk.accelerator_parse(__accel_key)

		if self.LIST_TAB_SHORTCUT.has_key(__key) :
			return
		else :
			self.LIST_TAB_SHORTCUT[__key] = num
			self.AccelGrpGlobal.add_key(__accel_key, __key, __mod, eval(__c[1]))

	def __toggle_full_screen (self) :
		if not self.IS_FULLSCREEN :
			self.WIDGET_SELF.fullscreen()

			# hide menubar, toolbar, statusbar.
			self.HIDE_WIDGET_CAUSED_BY_FULLSCREEN = list()
			if self.Statusbar.get_property("visible") :
				self.Statusbar.hide()
				self.HIDE_WIDGET_CAUSED_BY_FULLSCREEN.append(self.Statusbar)

			if self.Toolbar.get_property("visible") :
				self.Toolbar.hide()
				self.HIDE_WIDGET_CAUSED_BY_FULLSCREEN.append(self.Toolbar)

			if self.Menubar.get_property("visible") :
				self.Menubar.hide()
				self.HIDE_WIDGET_CAUSED_BY_FULLSCREEN.append(self.Menubar)
		else :
			self.WIDGET_SELF.unfullscreen()
			for i in self.HIDE_WIDGET_CAUSED_BY_FULLSCREEN :
				i.show()

		self.IS_FULLSCREEN = not self.IS_FULLSCREEN

		self.WIDGET_SELF.set_data("is-fullscreen", self.IS_FULLSCREEN)

	def __set_toolbar_icon_size (self, value=None) :
		if not value :
			value = self.GCONF_CLIENT.get_value("/desktop/gnome/interface/toolbar_icon_size")

		if value == "menu" :
			__size = gtk.ICON_SIZE_MENU
		elif value == "small-toolbar" :
			__size = gtk.ICON_SIZE_SMALL_TOOLBAR
		elif value == "large-toolbar" :
			__size = gtk.ICON_SIZE_LARGE_TOOLBAR
		elif value == "button" :
			__size = gtk.ICON_SIZE_BUTTON
		elif value == "dnd" :
			__size = gtk.ICON_SIZE_DND
		elif value == "dialog" :
			__size = gtk.ICON_SIZE_DIALOG
		else :
			__size = gtk.ICON_SIZE_LARGE_TOOLBAR

		self.Toolbar.set_icon_size(__size)

	def __set_toolbar_style (self, value=None) :
		if not value :
			value = self.GCONF_CLIENT.get_value("/desktop/gnome/interface/toolbar_style")

		if value == "both" :
			__style = gtk.TOOLBAR_BOTH
		elif value == "both_horiz" :
			__style = gtk.TOOLBAR_BOTH_HORIZ
		elif value == "icon" :
			__style = gtk.TOOLBAR_ICONS
		elif value == "text" :
			__style = gtk.TOOLBAR_TEXT
		else :
			__style = gtk.TOOLBAR_BOTH_HORIZ

		self.Toolbar.set_style(__style)

	def __set_geometry (self) :

		__wh = self.GCONF_CLIENT.get_value_by_conf("latest-window-geometry")
		__wh0 = [ int(i) for i in __wh.split(",")]
		__w, __h, __x, __y = __wh0

		if self.WIDGET_SELF.parse_geometry(self.ARGS_OPTIONS.ARG_GEOMETRY) :
			__w0, __h0, __x0, __y0 = \
				func.parse_geometry(self.ARGS_OPTIONS.ARG_GEOMETRY)

			if __w0 : __w = __w0
			if __h0 : __h = __h0
			if __x0 : __x = __x0
			if __y0 : __y = __y0

		"""
		Notice :
			resize() and set_size_request() will change the window
			size, but set_size_request keep the window from being
			smaller, so here i use resize().
		"""
		self.WIDGET_SELF.resize(int(__w), int(__h))
		self.WIDGET_SELF.move(__x, __y)

		self.WIDGET_SELF.set_data("window-size", self.WIDGET_SELF.get_size())

		if self.ARGS_OPTIONS.ARG_MAXIMIZE_WINDOW :
			self.WIDGET_SELF.maximize()

		self.WIDGET_SELF.connect( \
			"size_request", self.__window_size_changed)

		# check if the last window was fullscreened or not.
		if self.GCONF_CLIENT.get_value_by_conf("is-fullscreen") or \
				self.ARGS_OPTIONS.ARG_FULLSCREEN_WINDOW :
			self.__toggle_full_screen()

		self.WIDGET_SELF.set_data("is-fullscreen", self.IS_FULLSCREEN)

		# set bookmark panel height.
		self.xml.get_widget("vpaned1").set_position(200)

	def __set_menubar (self) :

		# set menu label.
		for i, j in i18n.LABEL_MAIN_MENU.items() :
			__m = self.xml.get_widget(i)
			if __m is None : continue
			__m.get_children()[0].set_label(j)

		# attach bookmark data.
		self.__insert_bookmark()

	def nf_update_bookmarks (self, client, parm1, parm2, parm3) :
		self.__insert_bookmark()

	def __insert_bookmark (self) :

		__item_root = self.BOOKMARKS.get_root()
		if len(__item_root) < 1 : return

		# add bookmark
		__bookmark = self.xml.get_widget("bookmark2")
		__bookmark.remove_submenu()

		# create icons.
		self.ICON_CATEGORY = func.create_icon(os.path.join(Conf__.DIR_PIXMAPS, \
			"category.png"))
		self.ICON_EXTERNAL_COMMAND = func.create_icon(os.path.join(Conf__.DIR_PIXMAPS, \
			"external-command.png"))
		self.ICON_TERMINAL = func.create_icon(os.path.join(Conf__.DIR_PIXMAPS, \
			"terminal.png"))
		self.ICON_VIM = func.create_icon(os.path.join(Conf__.DIR_PIXMAPS, \
			"vim.png"))
		self.ICON_GVIM = func.create_icon(os.path.join(Conf__.DIR_PIXMAPS, \
			"gvim.png"))

		__menu = gtk.Menu()

		for i in __item_root :
			self.__insert_item(__menu, i)

		__menu.show()
		__bookmark.set_submenu(__menu)

	def __append_item (self, parent, label, image, uid=None) :
		__i = gtk.ImageMenuItem(gtk.STOCK_OPEN)
		__i.set_data("uid", uid)
		__i.get_children()[0].set_label(label)
		__i.get_children()[1].set_from_pixbuf(image)

		parent.append(__i)
		__i.show()

		return __i

	def __insert_item (self, menuShell, uid) :
		__value = self.BOOKMARKS.get_value(uid, "asDict")

		if __value["type"] == "category" :
			__icon_type = self.ICON_CATEGORY
		elif __value["type"] == "vim" :
			__icon_type = self.ICON_VIM
		elif __value["type"] == "gvim" :
			__icon_type = self.ICON_GVIM
		elif __value["type"] == "terminal" :
			__icon_type = self.ICON_TERMINAL
		elif __value["type"] == "external_command" :
			__icon_type = self.ICON_EXTERNAL_COMMAND
		else :
			__icon_type = self.ICON_ETC

		__item = self.__append_item( \
			menuShell, __value["label"], __icon_type, uid)
		__item.connect("activate", self.on_bookmark_activated)

		__item_child = self.BOOKMARKS.get_child(uid)
		if len(__item_child) > 0 :
			__menuShell0 = gtk.Menu()

			for i in __item_child :
				self.__insert_item(__menuShell0, i)

			__item.set_submenu(__menuShell0)

	def on_bookmark_activated (self, widget) :

		uid = widget.get_data("uid")
		__data = self.BOOKMARKS.get_value(uid, "asDict")

		try :
			__setting = self.BOOKMARKS.get_setting(uid)
		except IndexError :
			__setting = None

		# run command.
		if __data["type"] == "terminal" :
			self.addPage(__data["type"], directory=__data["value"], setting=__setting)
		elif __data["type"] == "external_command" :
			self.addPage(__data["type"], external_command=__data["value"], setting=__setting)
		elif __data["type"] in ("vim", "gvim") :
			self.addPage(__data["type"], filename=__data["value"], setting=__setting)

		return

	def reset_child (self) :
		__n = self.NOTEBOOK.get_current_page()
		self.LIST_TAB.get_child(__n).reset()

	def addLogo (self) :

		Logo = gtk.Image()
		Logo.set_from_file(os.path.join(Conf__.DIR_PIXMAPS, "vee-logo.png"))
		Logo.show()

		__eventbox = gtk.EventBox()
		__eventbox.add(Logo)
		__eventbox.show()

		tab = TAB.One( \
			state=self.STATE, \
			without_closebutton=True)

		tab.addWidget(__eventbox, _("VEE"))
		self.WIDGET_SELF.set_title(_("vee"))

		self.IS_LOGO = True

	def addPage (self, childname, **kwargs) :
		if self.GCONF_CLIENT.get_value_by_conf( \
				"use-%s" % childname) is False :
			return

		if self.IS_LOGO :
			self.NOTEBOOK.remove_page(0)
			self.IS_LOGO = False

		__tab = child.getTab(childname)
		tab = __tab(self.STATE, **kwargs)

		tab.make()

		self.__addAccelKeySwitchTab()

		current_page = self.NOTEBOOK.get_current_page()
		self.HISTORY_TAB.add(current_page)

	def install_accel_group (self, conf_accel_keys) :
		__GROUP = Accel.Group(self.GCONF_CLIENT)

		for i in conf_accel_keys :
			__key, __mod, __callback = __GROUP.get_data_by_gconf(i)
			if not __key : continue

			if not __GROUP.add_key( \
					os.path.basename(Conf.SCHEMA[i]["key"]), \
					__key, __mod, eval(__callback)) :
				raise RuntimeError, "The key, %s was failed to install." % \
					__accel_keys
			else :
				# add gconf notification.
				self.GCONF_CLIENT.CLIENT.notify_add( \
					Conf.SCHEMA[i]["key"], self.nf_update_accel_key)

		__GROUP.add_to_window(self.WIDGET_SELF)

		return __GROUP

	def nf_update_accel_key (self, client, parm1, entry, parm3) :
		uid = os.path.basename(entry.get_key())

		# get new key and mods.
		__key, __mod = \
			gtk.accelerator_parse( \
				self.GCONF_CLIENT.get_value_from_value(entry.get_value()))

		if not __key or __mod == Conf.NULL_MODIFIER_MASK : return

		return self.AccelGrpGlobal.update_key(uid, __key, __mod)

class NoValidCommand (WIDGET.WIDGET) :

	def __init__ (self, command=str()) :
		WIDGET.WIDGET.__init__(self, "error")

		self.WIDGET_SELF.set_title(_("This command does not exist. Check it out."))

		if command.strip() :
			__label = self.xml.get_widget("label90")
			__label.set_label( \
				_("\n'%s' does not exist. Check it.\n\n") % command \
			)

class TabList (WIDGET.WIDGET) :

	STATE = None
	LIST_TAB = list()
	NOTEBOOK = None

	CURRENT_PAGE = int()

	BOX = None

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")

		self.STATE = kwargs["state"]
		self.LIST_TAB = self.STATE.get_value("tab-list")
		self.NOTEBOOK = self.STATE.get_value("notebook")

		# get current page.
		self.CURRENT_PAGE = self.NOTEBOOK.get_current_page()

		WIDGET.WIDGET.__init__(self, "tablist", None)

		self.__create_list()

		# set label.
		self.WIDGET_SELF.set_title(_("List Tabs."))
		__label = self.xml.get_widget("label101")
		__label.set_label(_("<b>Tab List - Select One.</b>"))

	def __create_list (self) :
		self.BOX = self.xml.get_widget("vbox19")
		__n = 0
		for i in self.LIST_TAB :
			# get the name of each tab.
			__t = i.Child.CHILD_TYPE
			if __t == child.TYPE_TERMINAL :
				__type = "terminal"
				__label = i.Child.DIRECTORY
			elif __t == child.TYPE_EXTERNAL_COMMAND :
				__type = "external_command"
				__label = i.Child.EXTERNAL_COMMAND
			elif __t == child.TYPE_VIM :
				__type = "vim"
				__label = i.Child.FILENAME
			elif __t == child.TYPE_GVIM :
				__type = "gvim"
				__label = i.Child.FILENAME
			else :
				return

			self.append_item(__type, __label, __n + 1)
			__n += 1

		__1st = self.BOX.get_children()[self.CURRENT_PAGE]
		__1st.set_active(True)
		__1st.grab_focus()

	def append_item (self, type, label, seq) :
		__label = gtk.Label(" %d : %s" % (seq, label))
		__image = self.get_icon(type)
		__label.show()
		__image.show()

		__box = gtk.HBox()
		__box.pack_start(__image, expand=False, fill=False)
		__box.pack_start(__label, expand=False, fill=False)
		__box.set_property("homogeneous", False)
		__box.show()

		__button = gtk.ToggleButton()
		__button.add(__box)
		__button.set_data("seq", seq)
		__button.show()

		__button.connect("focus_out_event", self.on_unselect_item)
		__button.connect("focus_in_event", self.on_select_item)
		__button.connect("event", self.on_select_event)

		self.BOX.pack_start(__button)

	def on_unselect_item (self, widget, event) :
		widget.set_active(False)

	def on_select_item (self, widget, event) :
		widget.set_active(True)

	def on_select_event (self, widget, event) :
		try :
			event.keyval
		except AttributeError :
			return

		if event.keyval == 65293 :
			num_page = widget.get_data("seq") - 1
			self.NOTEBOOK.set_current_page(num_page)

	def get_icon (self, type) :

		if type == "category" :
			__path = os.path.join(Conf__.DIR_PIXMAPS, "category.png")
		elif type == "terminal" :
			__path = os.path.join(Conf__.DIR_PIXMAPS, "terminal.png")
		elif type == "external_command" :
			__path = os.path.join(Conf__.DIR_PIXMAPS, "external-command.png")
		elif type == "vim" :
			__path = os.path.join(Conf__.DIR_PIXMAPS, "vim.png")
		elif type == "gvim" :
			__path = os.path.join(Conf__.DIR_PIXMAPS, "gvim.png")

		# create category icon image
		__p = gtk.gdk.pixbuf_new_from_file_at_size(__path, 50, 50)
		__i = gtk.Image()
		__i.set_from_pixbuf(__p)

		return __i

class ExternalCommand (WIDGET.WIDGET) :

	ENTRY_EXTERNAL_COMMAND = None
	LISTSTORE = None
	STATE = None
	CALLBACK_FUNCTIONS = dict()
	TREEVIEW_LAST_COMMAND = None

	GCONF_CLIENT = None

	LIST_STORED = list()

	def __init__ (self, **kwargs) :

		if not kwargs.has_key("completion_liststore") :
			raise ValueError, _("completion_liststore must be included.")
		else :
			self.LISTSTORE = kwargs["completion_liststore"]

		if not kwargs.has_key("state") :
			raise ValueError, _("state must be included.")
		else :
			self.STATE = kwargs["state"]

		if not kwargs.has_key("callback_functions") :
			raise ValueError, _("callback_functions must be included.")
		else :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		WIDGET.WIDGET.__init__( \
			self, "external_command", None, dict(), Handler.ExternalCommand)

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		self.BOX_LAST_COMMAND = self.xml.get_widget("vbox17")

		__label = self.xml.get_widget("label92")
		__label.set_label(_("Run Command"))

		self.ENTRY_EXTERNAL_COMMAND = self.xml.get_widget("comboboxentry1")
		__completion = gtk.EntryCompletion()
		self.ENTRY_EXTERNAL_COMMAND.child.set_completion(__completion)
		self.ENTRY_EXTERNAL_COMMAND.child.grab_focus()
		self.ENTRY_EXTERNAL_COMMAND.child.connect("activate", self.on_ok)
		self.ENTRY_EXTERNAL_COMMAND.child.connect( \
			"changed", self.on_changed_entry)

		__completion.set_model(self.LISTSTORE)
		__completion.set_text_column(0)

		# saved command list.
		self.EXPANDER = self.xml.get_widget("expander1")
		self.EXPANDER.connect("notify::expanded", self.expander_callback)

		__state_expander = \
			self.STATE.get_value("run-command-expander-state", False)
		self.EXPANDER.set_expanded(__state_expander)

		self.WIDGET_SELF.set_title(_("Run Command"))

		# buttons
		self.BUTTON_ADD = self.xml.get_widget("button_add")
		self.BUTTON_ADD.set_property("sensitive", False)
		self.BUTTON_REMOVE = self.xml.get_widget("button_remove")
		self.BUTTON_REMOVE.set_property("sensitive", False)

		for i, j in i18n.LABEL_EXTERNAL_COMMAND.items() :
			self.xml.get_widget(i).set_label(j)

		self.__load_list()
		self.__create_treeview()

	def __load_list (self) :

		# get the stored list of external command list.
		__data = self.GCONF_CLIENT.get_value_by_conf("external-command-list")

		try :
			__data0 = base64.decodestring(__data)
			__data1 = marshal.loads(__data0)
		except EOFError :
			__data1 = list()

		if type(__data1) is list :
			self.LIST_STORED = __data1

	def __store_list (self) :
		__data = marshal.dumps(self.LIST_STORED)
		__data0 = base64.encodestring(__data)

		self.GCONF_CLIENT.set_value_by_conf( \
			"external-command-list", \
			__data0 \
		)

	def __store_item (self, command) :
		self.LIST_STORED.append(command)
		self.__store_list()

	def on_changed_entry (self, widget) :
		__d = widget.get_text().strip()

		if len(__d) < 1 :
			self.BUTTON_ADD.set_property("sensitive", False)
		else :
			self.BUTTON_ADD.set_property("sensitive", True)

	def __create_treeview (self) :
		self.TREEVIEW_LAST_COMMAND = self.xml.get_widget("treeview3")
		self.TREEVIEW_LAST_COMMAND.set_headers_visible(False)

		# connect signal
		self.TREEVIEW_LAST_COMMAND.connect( \
			"cursor-changed", self.on_select_command)
		self.TREEVIEW_LAST_COMMAND.connect( \
			"row-activated", self.on_ok)

		# create a CellRenderers to render the data
		tvcolumn = gtk.TreeViewColumn("")
		tvcolumn.set_expand(True)
		tvcolumn.set_sort_column_id(0)

		self.LISTSTORE = gtk.ListStore(str)
		self.TREEVIEW_LAST_COMMAND.set_model(self.LISTSTORE)
		self.TREEVIEW_LAST_COMMAND.append_column(tvcolumn)

		# add the cells to the columns - 2 in the first
		cell = gtk.CellRendererText()
		tvcolumn.pack_start(cell, True)
		tvcolumn.set_attributes(cell, text=0)

		self.TREEVIEW_LAST_COMMAND.set_reorderable(True)

		for i in self.LIST_STORED :
			self.__append_command(i)

	def __append_command (self, command) :
		if not command.strip() : return

		self.LISTSTORE.append(("%s" % command,))
		return

	def on_select_command (self, widget) :
		__tree_selection = self.TREEVIEW_LAST_COMMAND.get_selection()
		(__tree_store, __tree_iter) = __tree_selection.get_selected()
		try :
			__value = self.LISTSTORE.get_value(__tree_iter, 0)
		except TypeError :
			return

		self.ENTRY_EXTERNAL_COMMAND.child.set_text(__value)
		self.BUTTON_REMOVE.set_property("sensitive", True)

	def on_add_command (self, widget) :
		__c = self.ENTRY_EXTERNAL_COMMAND.child.get_text()
		if len(__c.strip()) < 1 : return

		self.__append_command(__c)
		# after add in tree, make entry to be blank.
		self.ENTRY_EXTERNAL_COMMAND.child.set_text("")

		self.__store_item(__c)

	def on_remove_command (self, widget) :
		__tree_selection = self.TREEVIEW_LAST_COMMAND.get_selection()
		(__tree_store, __tree_iter) = __tree_selection.get_selected()
		try :
			__path = self.LISTSTORE.get_path(__tree_iter)
		except TypeError :
			return

		self.LISTSTORE.remove(__tree_iter)
		self.ENTRY_EXTERNAL_COMMAND.child.set_text("")

		del(self.LIST_STORED[__path[0]])
		self.__store_list()

	def expander_callback(self, expander, param_spec, user_data=None):
		if expander.get_expanded():
			self.BOX_LAST_COMMAND.show()
			self.WIDGET_SELF.set_property("resizable", True)
		else:
			self.BOX_LAST_COMMAND.hide()
			self.WIDGET_SELF.set_property("resizable", False)

		self.STATE.set_value( \
			"run-command-expander-state", expander.get_expanded())

	def on_ok (self, widget, parm1=None, parm2=None) :
		__c = self.ENTRY_EXTERNAL_COMMAND.child.get_text()
		if len(__c.strip()) < 1 : return

		parsed_argv = func.parse_command_line_argument(__c)

		if len(parsed_argv["command"].strip()) < 1 : return

		if not func.is_valid_command(parsed_argv["command"]) :
			NoValidCommand(parsed_argv["command"])
			return

		self.LISTSTORE.append([__c, ])
		__func = self.CALLBACK_FUNCTIONS["addPage"]
		__func("external_command", external_command=__c.strip())

		self.on_close(widget)

class About (WIDGET.WIDGET) :
	"""
	 "authors"              GValueArray           : Write
	 "comments"             gchararray            : Read / Write
	 "copyright"            gchararray            : Read / Write
	 "documenters"          GValueArray           : Write
	 "logo"                 GdkPixbuf             : Write
	 "name"                 gchararray            : Read / Write
	 "translator-credits"   gchararray            : Read / Write
	 "version"              gchararray            : Read / Write
	"""

	def __init__ (self) :
		WIDGET.WIDGET.__init__(self, "about")

		for i, j in Conf__.INFO.items() :
			self.WIDGET_SELF.set_property(i, _(j))

	def on_ok (self, widget) :
		self.on_close(widget)

class Preferences (WIDGET.WIDGET) :

	COLUMN_LABEL = 0
	COLUMN_KEYVAL = 1
	COLUMN_CONF_KEY = 2

	GCONF_CLIENT = None

	FONT_DEFAULT_SYSTEM = str()

	TAB_POSITION = ("Bottom", "Top", "Left", "Right")
	INITIAL_MODULE = ("None", "vim", "gvim", "terminal",)

	CURRENT_PATH = None
	SHORTCUT_KEY_VALUE_ORG = None
	__KEYBOARD_SHORTCUT_IN_USE = None

	def __init__ (self) :

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		WIDGET.WIDGET.__init__(self, "preferences", None, dict(), Handler.PREFERENCES)

		# get widget
		__checkbutton_hide_menubar = self.xml.get_widget("checkbutton13")
		__checkbutton_hide_toolbar = self.xml.get_widget("checkbutton14")
		__checkbutton_hide_bookmark = self.xml.get_widget("checkbutton15")
		__checkbutton_hide_statusbar = self.xml.get_widget("checkbutton18")

		__widget_font = self.xml.get_widget("fontbutton3")
		__widget_font_system_default = self.xml.get_widget("checkbutton12")
		__widget_command_vim = self.xml.get_widget("entry13")
		__widget_command_gvim = self.xml.get_widget("entry16")
		__widget_command_terminal = self.xml.get_widget("entry14")
		__widget_max_scrollline = self.xml.get_widget("spinbutton1")

		# set label name
		for i, j in i18n.LABEL_PREFERENCES.items() :
			self.xml.get_widget(i).set_label(j)

		# set default system font.
		self.FONT_DEFAULT_SYSTEM = self.GCONF_CLIENT.get_value( \
				Conf.GLOBAL_FONT_SYSTEM_DEFAULT)

		# set tab position
		__tab_position =  \
			self.GCONF_CLIENT.get_value_by_conf("tab-position")
		__tp = self.xml.get_widget("combobox3")
		for i in range(len(self.TAB_POSITION)) :
			__tp.insert_text(i, _(self.TAB_POSITION[i]))

		try :
			__position = list(self.TAB_POSITION).index(__tab_position)
		except ValueError :
			__position = 0

		__tp.set_active(__position)

		# startup module,
		__value_initial_module =  \
			self.GCONF_CLIENT.get_value_by_conf("initial-module")
		__initial_module = self.xml.get_widget("combobox4")
		if __value_initial_module not in self.INITIAL_MODULE :
			__value_initial_module = "None"

		for i in range(len(self.INITIAL_MODULE)) :
			__initial_module.insert_text(i, _(self.INITIAL_MODULE[i]))
			if self.INITIAL_MODULE[i] == __value_initial_module :
				__initial_module.set_active(i)

		# set font name
		__fontname = self.GCONF_CLIENT.get_value_by_conf("font")
		if __fontname :
			__widget_font.set_font_name(__fontname)

		__use_system_default_font = \
			self.GCONF_CLIENT.get_value_by_conf("use-system-default-font")

		if __use_system_default_font :
			__widget_font.set_sensitive(False)
			__widget_font_system_default.set_active(True)
		else :
			__widget_font_system_default.set_active(False)

		# show/hide menubar, toolbar, bookmark
		__show_menubar = \
			self.GCONF_CLIENT.get_value_by_conf("show-menubar")
		__checkbutton_hide_menubar.set_active(__show_menubar)

		__show_toolbar = \
			self.GCONF_CLIENT.get_value_by_conf("show-toolbar")
		__checkbutton_hide_toolbar.set_active(__show_toolbar)

		__show_statusbar = \
			self.GCONF_CLIENT.get_value_by_conf("show-statusbar")
		__checkbutton_hide_statusbar.set_active(__show_statusbar)

		__show_bookmark = \
			self.GCONF_CLIENT.get_value_by_conf("show-bookmark")
		__checkbutton_hide_bookmark.set_active(__show_bookmark)

		__command_vim = self.GCONF_CLIENT.get_value_by_conf("command-vim")
		__command_gvim = self.GCONF_CLIENT.get_value_by_conf("command-gvim")
		__command_terminal = \
			self.GCONF_CLIENT.get_value_by_conf("command-terminal")

		__widget_command_vim.set_text(__command_vim)
		__widget_command_gvim.set_text(__command_gvim)
		__widget_command_terminal.set_text(__command_terminal)

		# max scrollable line
		__value_max_scrollline = \
			self.GCONF_CLIENT.get_value_by_conf("max-scrollline")

		__widget_max_scrollline.set_value(int(__value_max_scrollline))

		# set color
		__colorbutton_foreground = self.xml.get_widget("colorbutton1")
		__colorbutton_foreground.connect( \
			"color-set", self.on_color_changed, "foreground")
		__c = self.GCONF_CLIENT.get_value_by_conf("color-foreground")
		__gdkColor = func.str_to_color(__c, "white")
		__colorbutton_foreground.set_color(__gdkColor)

		__colorbutton_background = self.xml.get_widget("colorbutton2")
		__colorbutton_background.connect( \
			"color-set", self.on_color_changed, "background")
		__c = self.GCONF_CLIENT.get_value_by_conf("color-background")
		__gdkColor = func.str_to_color(__c, "black")
		__colorbutton_background.set_color(__gdkColor)

		__colorbutton_dim = self.xml.get_widget("colorbutton3")
		__colorbutton_dim.connect( \
			"color-set", self.on_color_changed, "dim")
		__c = self.GCONF_CLIENT.get_value_by_conf("color-dim")
		__gdkColor = func.str_to_color(__c, "white")
		__colorbutton_dim.set_color(__gdkColor)

		__colorbutton_highlight = self.xml.get_widget("colorbutton4")
		__colorbutton_highlight.connect( \
			"color-set", self.on_color_changed, "highlight")
		__c = self.GCONF_CLIENT.get_value_by_conf("color-highlight")
		__gdkColor = func.str_to_color(__c, "white")
		__colorbutton_highlight.set_color(__gdkColor)

		__colorbutton_cursor = self.xml.get_widget("colorbutton5")
		__colorbutton_cursor.connect( \
			"color-set", self.on_color_changed, "cursor")
		__c = self.GCONF_CLIENT.get_value_by_conf("color-cursor")
		__gdkColor = func.str_to_color(__c, "red")
		__colorbutton_cursor.set_color(__gdkColor)

		# check the usage of the commands?
		__use_vim = \
			self.GCONF_CLIENT.get_value_by_conf("use-vim")
		__checkbutton_vim = self.xml.get_widget("checkbutton19")
		__checkbutton_vim.set_active(not __use_vim)

		__use_gvim = \
			self.GCONF_CLIENT.get_value_by_conf("use-gvim")
		__checkbutton_gvim = self.xml.get_widget("checkbutton20")
		__checkbutton_gvim.set_active(not __use_gvim)

		__use_terminal = \
			self.GCONF_CLIENT.get_value_by_conf("use-terminal")
		__checkbutton_terminal = self.xml.get_widget("checkbutton21")
		__checkbutton_terminal.set_active(not __use_terminal)

		###########################################################################33
		# set Effect section

		# set background type.
		self.RADIOBUTTON_NONE = self.xml.get_widget("radiobutton4")
		self.RADIOBUTTON_IMAGE = self.xml.get_widget("radiobutton5")
		self.RADIOBUTTON_TRANS = self.xml.get_widget("radiobutton6")

		self.RADIOBUTTON_NONE.connect("toggled", self.on_change_background_type, "None")
		self.RADIOBUTTON_IMAGE.connect("toggled", self.on_change_background_type, "image-file")
		self.RADIOBUTTON_TRANS.connect("toggled", self.on_change_background_type, "transparent")

		__background_type = self.GCONF_CLIENT.get_value_by_conf("vte-background-type")

		if __background_type == "transparent" :
			self.RADIOBUTTON_TRANS.set_active(True)
		elif __background_type == "image-file" :
			__image_file = \
				self.GCONF_CLIENT.get_value_by_conf("vte-background-image-file")

			if os.path.isfile(__image_file) :
				self.RADIOBUTTON_IMAGE.set_active(True)
				self.xml.get_widget("combo-entry2").set_text(__image_file)
			else :
				self.RADIOBUTTON_NONE.set_active(True)
		else :
			self.RADIOBUTTON_NONE.set_active(True)

		# set shade when transparent background
		__scale_shade = self.GCONF_CLIENT.get_value_by_conf("vte-background-shade")

		if __scale_shade < 0 or __scale_shade > 1 : __scale_shade = 0.2
		self.xml.get_widget("hscale1").set_value(__scale_shade)

		# set keyboard shortcut page.
		self.TREEVIEW_KEYBOARD_SHORTCUT = self.xml.get_widget("treeview6")
		#self.TREEVIEW_KEYBOARD_SHORTCUT.set_headers_visible(False)
		self.TREEVIEW_KEYBOARD_SHORTCUT.set_reorderable(False)

		self.EVENTBOX = self.xml.get_widget("eventbox3")
		self.EVENTBOX.set_events(gtk.gdk.KEY_RELEASE)
		self.EVENTBOX.add_events(gtk.gdk.KEY_PRESS)

		# connect event.
		self.TREEVIEW_KEYBOARD_SHORTCUT.connect( \
			"row-activated", self.on_accel_activated)

		self.EVENTBOX.connect("key-release-event", self.on_grab_keyval)

		self.__create_frame()
		self.TREESTORE.clear()

		# insert bookmarks data into treeview.
		for i, j in Conf.KEYBOARD_SHORTCUT_LIST_FOR_TREEVIEW.items() :
			__category = self.TREESTORE.append(None, [_(i), str(), str()])

			for k, m in j :
				__key_value = self.GCONF_CLIENT.get_value_by_conf(k)
				__iter_parent = self.add_item( \
					__category, k, _(m), __key_value)

		self.TREEVIEW_KEYBOARD_SHORTCUT.expand_all()

	def on_accel_activated (self, treeview, path, view_column, user_param1=None) :
		self.SHORTCUT_KEY_VALUE_ORG = self.get_value(path, self.COLUMN_KEYVAL)

		if not self.SHORTCUT_KEY_VALUE_ORG.strip() : return

		self.TREESTORE[path][1] = _("New Accelerator...")
		self.CURRENT_PATH = path

		return

	def __accel_disable (self) :
		self.TREESTORE[self.CURRENT_PATH][1] = _("Disabled")
		self.CURRENT_PATH = None

	def __accel_cancel (self) :
		self.TREESTORE[self.CURRENT_PATH][1] = self.SHORTCUT_KEY_VALUE_ORG
		self.CURRENT_PATH = None

	def get_value (self, path, column_number) :
		__tree_iter = self.TREESTORE.get_iter(path)
		__value = self.TREESTORE.get_value(__tree_iter, column_number)

		return __value

	def on_grab_keyval (self, widget, event) :
		if not self.CURRENT_PATH : return

		__conf_key = self.get_value(self.CURRENT_PATH, self.COLUMN_CONF_KEY)
		if not Conf.SCHEMA.has_key(__conf_key) : self.__accel_cancel()

		__keyval_name = gtk.gdk.keyval_name(event.keyval)

		#__mod = event.state & gtk.gdk.MODIFIER_MASK
		__mod = event.state & Conf.AVAILABLE_MODIFIER_MASK
		if __mod == Conf.NULL_MODIFIER_MASK :

			# if backspace, cancel the operation.
			if __keyval_name == "BackSpace" :
				self.__accel_disable()
			elif __keyval_name == "Escape" :
				self.__accel_cancel()
			elif __keyval_name != "Return" :
				self.__accel_cancel()

			return

		if not __keyval_name : return
		if not __keyval_name.strip() : return

		if not gtk.accelerator_valid(event.keyval, event.state) : return

		# check the symbols caused by SHIFT key.
		__key_string = gtk.gdk.keyval_name(event.keyval)
		if Conf.UPPER_SYMBOLS.has_key(__key_string) :
			mods = event.state & ~ gtk.gdk.SHIFT_MASK
		else :
			mods = event.state

		# store key event.
		if len(__key_string) == 1 : __key_string = __key_string.upper()

		__key_name = gtk.accelerator_name(event.keyval, mods)

		# filtering the close this window.
		if __key_name == "<Control>c" : self.__accel_cancel()

		__key_value = ">".join(__key_name.split(">")[:-1]) + ">" + \
			__key_string

		# check this key is already in use.
		self.__KEYBOARD_SHORTCUT_IN_USE = None
		self.TREESTORE.foreach(self.__search_keyval_in_column, __key_value)

		if self.__KEYBOARD_SHORTCUT_IN_USE and len(self.__KEYBOARD_SHORTCUT_IN_USE) == 2:
				Dialog.ShortcutKeyInUse(__key_value, self.__KEYBOARD_SHORTCUT_IN_USE[1])
				self.__accel_cancel()
				return

		# update gconf value.
		if not self.GCONF_CLIENT.set_value_by_conf( \
				__conf_key, __key_value) :
			raise RuntimeError, \
				_("Keyboard shortcut did not update, caused by gconf.")

		self.TREESTORE[self.CURRENT_PATH][1] = __key_value
		self.CURRENT_PATH = None

		return

	def __search_keyval_in_column (self, model, path, iter, key_value) :
		if self.get_value(path, self.COLUMN_KEYVAL) == key_value :
			self.__KEYBOARD_SHORTCUT_IN_USE = (path, self.get_value(path, self.COLUMN_LABEL), )

			return True
		else :
			return False

	def __create_frame (self) :

		# create a CellRenderers to render the data
		self.cell = gtk.CellRendererText()
		self.cell1 = gtk.CellRendererText()
		self.cell2 = gtk.CellRendererText()

		self.tvcolumn = gtk.TreeViewColumn(_("Action"))
		self.tvcolumn1 = gtk.TreeViewColumn(_("Shortcut"))

		self.tvcolumn.set_expand(True)
		self.tvcolumn.set_sort_column_id(self.COLUMN_LABEL)

		self.TREESTORE = gtk.TreeStore(str, str, str)
		self.TREEVIEW_KEYBOARD_SHORTCUT.set_model(self.TREESTORE)

		self.TREEVIEW_KEYBOARD_SHORTCUT.append_column(self.tvcolumn)
		self.TREEVIEW_KEYBOARD_SHORTCUT.append_column(self.tvcolumn1)

		self.tvcolumn.pack_start(self.cell, False)
		self.tvcolumn1.pack_start(self.cell1, True)
		self.tvcolumn1.pack_start(self.cell2, False)

		self.tvcolumn.set_attributes(self.cell, text=0)
		self.tvcolumn1.set_attributes(self.cell1, text=1)

	def add_item (self, parent, conf_key, label, keyval) :
		child = self.TREESTORE.append(parent, [label, keyval, conf_key, ])
		return child

	####################################################################
	# HANDLER
	def on_change_background_image_file (self, widget) :
		__value = self.xml.get_widget("combo-entry2").get_text()
		self.GCONF_CLIENT.set_value_by_conf("vte-background-image-file", __value)

	def on_change_saturation (self, widget) :
		__value = round(widget.get_value(), 1)
		self.GCONF_CLIENT.set_value_by_conf("vte-background-shade", __value)

	def on_change_background_type (self, widget, type) :
		self.GCONF_CLIENT.set_value_by_conf("vte-background-type", type)

	def on_not_use_vim (self, widget) :
		__is_activated = widget.get_active()
		self.xml.get_widget("entry13").set_property( \
			"sensitive", not __is_activated)

		return self.GCONF_CLIENT.set_value_by_conf( \
			"use-vim", not __is_activated)

	def on_not_use_gvim (self, widget) :
		__is_activated = widget.get_active()
		self.xml.get_widget("entry16").set_property( \
			"sensitive", not __is_activated)

		return self.GCONF_CLIENT.set_value_by_conf( \
			"use-gvim", not __is_activated)

	def on_not_use_terminal (self, widget) :
		__is_activated = widget.get_active()
		self.xml.get_widget("entry14").set_property( \
			"sensitive", not __is_activated)

		return self.GCONF_CLIENT.set_value_by_conf( \
			"use-terminal", not __is_activated)

	def on_change_initial_module (self, widget) :
		__pos = widget.get_active()

		self.GCONF_CLIENT.set_value_by_conf( \
			"initial-module", \
			self.INITIAL_MODULE[__pos] \
		)

	def on_change_tab_position (self, widget) :
		__pos = widget.get_active()

		self.GCONF_CLIENT.set_value_by_conf( \
			"tab-position", \
			self.TAB_POSITION[__pos] \
		)

	def on_color_changed (self, widget, type) :
		__c = func.color_to_str(widget.get_color())
		self.GCONF_CLIENT.set_value_by_conf( \
			"color-%s" % (type), \
			__c
		)

	def on_change_terminal (self, widget) :
		self.GCONF_CLIENT.set_value_by_conf( \
			"command-terminal", \
			widget.get_text())

	def on_change_vim (self, widget) :
		self.GCONF_CLIENT.set_value_by_conf( \
			"command-vim", \
			widget.get_text())

	def on_change_gvim (self, widget) :
		self.GCONF_CLIENT.set_value_by_conf( \
			"command-gvim", \
			widget.get_text())

	def on_toggle_menubar (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value_by_conf( \
			"show-menubar", __is_activated)

	def on_toggle_toolbar (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value_by_conf("show-toolbar", __is_activated)

	def on_toggle_statusbar (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value_by_conf("show-statusbar", __is_activated)

	def on_toggle_bookmark (self, widget) :
		__is_activated = widget.get_active()
		self.GCONF_CLIENT.set_value_by_conf("show-bookmark", __is_activated)

	def on_font_set (self, widget) :
		__fontname = widget.get_font_name()
		self.GCONF_CLIENT.set_value_by_conf("font", __fontname)

	def on_use_system_font (self, widget) :

		__checkbutton = self.xml.get_widget("checkbutton12")
		__buttonFont = self.xml.get_widget("fontbutton3")
		__labelFont = self.xml.get_widget("label75")

		if __checkbutton.get_active() :
			__buttonFont.set_sensitive(False)
			__labelFont.set_sensitive(False)
			self.GCONF_CLIENT.set_value_by_conf( \
				"use-system-default-font", True)
		else :
			self.GCONF_CLIENT.set_value_by_conf( \
				"use-system-default-font", False)
			__buttonFont.set_sensitive(True)

			__labelFont.set_sensitive(True)

	def on_change_max_scrollline (self, widget) :
		__value = widget.get_value()

		self.GCONF_CLIENT.set_value_by_conf( \
			"max-scrollline", int(__value))

class BookmarkItemSetting (WIDGET.WIDGET) :
	"""
		Setting DATA : dict {
			"command" : ..,
			"font" : ..,
			"use-system-default-font" : ..,
			"color-foreground" : ..,
			"color-background" : ..,
			"color-dim" : ..,
			"color-highlight" : ..,
			"color-cursor" : ..,
			"max-scroll-line" : ..,
		}
	"""

	GCONF_CLIENT = None
	SETTING = None
	DATA = None
	PATH = None
	BOOKMARKS = None
	STATE = None

	def __init__ (self, path, data, **kwargs) :

		if not kwargs.has_key("state") :
			raise RuntimeError, "state must be given."
		else :
			self.STATE = kwargs["state"]
			self.BOOKMARKS = self.STATE.get_value("bookmark")

		if not kwargs.has_key("setting") :
			raise RuntimeError, "setting must be given."
		else :
			self.SETTING = kwargs["setting"]

		# read data
		self.DATA = data
		self.PATH = path

		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		WIDGET.WIDGET.__init__( \
			self, "bookmark_item_setting_terminal", None, \
			dict(), Handler.BookmarkItemSetting)

		####################################################################
		# set label name
		if self.DATA["type"] == "vim" :
			i18n.LABEL_BOOKMARK_SETTING["label144"] = _("VIM Command :")
		elif self.DATA["type"] == "gvim" :
			i18n.LABEL_BOOKMARK_SETTING["label144"] = _("GVIM Command :")
		elif self.DATA["type"] == "terminal" :
			i18n.LABEL_BOOKMARK_SETTING["label144"] = _("Terminal Command :")
		elif self.DATA["type"] == "external_command" :
			i18n.LABEL_BOOKMARK_SETTING["label144"] = _("External Command :")
		else :
			i18n.LABEL_BOOKMARK_SETTING["label144"] = _("Command :")

		for i, j in i18n.LABEL_BOOKMARK_SETTING.items() :
			try :
				self.xml.get_widget(i).set_label(j)
			except :
				continue

		##############################################################
		## ASSIGN VALUE

		# set label name
		self.xml.get_widget("entry17").set_text(self.DATA["label"])
		self.xml.get_widget("entry18").set_text(self.DATA["value"])

		# command
		if self.DATA["type"] == "vim" :
			__default = \
				self.GCONF_CLIENT.get_value_by_conf("command-vim")
			__value_command = \
				self.__get_value_from_data("command", __default)
		elif self.DATA["type"] == "gvim" :
			__default = \
				self.GCONF_CLIENT.get_value_by_conf("command-gvim")
			__value_command = \
				self.__get_value_from_data("command", __default)
		elif self.DATA["type"] == "terminal" :
			__default = \
				self.GCONF_CLIENT.get_value_by_conf("command-terminal")
			__value_command = \
				self.__get_value_from_data("command", __default)
		elif self.DATA["type"] == "external_command" :
			__default = self.DATA["value"]
			__value_command = \
				self.__get_value_from_data("command", __default)
		else :
			__value_command = ""

		self.xml.get_widget("combo-entry1").set_text(__value_command)

		# font
		__value_use_system_default =\
			self.__get_value_from_data("use-system-default-font", False)
		self.SETTING["use-system-default-font"] = \
			__value_use_system_default
		self.xml.get_widget("checkbutton22").set_active(__value_use_system_default)

		__default = \
			self.GCONF_CLIENT.get_value_by_conf("font")
		__value_font = \
			self.__get_value_from_data("font", __default)
		self.SETTING["font"] = __value_font

		WIDGET_FONT = self.xml.get_widget("fontbutton5")
		WIDGET_FONT.set_font_name(__value_font)

		WIDGET_FONT.set_property("sensitive", not __value_use_system_default)

		# colors
		__default_color_foreground =\
			self.GCONF_CLIENT.get_value_by_conf("color-foreground")
		__default_color_background =\
			self.GCONF_CLIENT.get_value_by_conf("color-background")
		__default_color_dim =\
			self.GCONF_CLIENT.get_value_by_conf("color-dim")
		__default_color_highlight =\
			self.GCONF_CLIENT.get_value_by_conf("color-highlight")
		__default_color_cursor =\
			self.GCONF_CLIENT.get_value_by_conf("color-cursor")

		__value_color_foreground =\
			self.__get_value_from_data("color-foreground", __default_color_foreground)
		if not __value_color_foreground.strip() :
			__value_color_foreground = __default_color_foreground

		__value_color_background =\
			self.__get_value_from_data("color-background", __default_color_background)
		if not __value_color_background.strip() :
			__value_color_background = __default_color_background

		__value_color_dim =\
			self.__get_value_from_data("color-dim", __default_color_dim)
		if not __value_color_dim.strip() :
			__value_color_dim = __default_color_dim

		__value_color_highlight =\
			self.__get_value_from_data("color-highlight", __default_color_highlight)
		if not __value_color_highlight.strip() :
			__value_color_highlight = __default_color_highlight

		__value_color_cursor =\
			self.__get_value_from_data("color-cursor", __default_color_cursor)
		if not __value_color_cursor.strip() :
			__value_color_cursor = __default_color_cursor

		self.SETTING["color-foreground"] = __value_color_foreground
		self.SETTING["color-background"] = __value_color_background
		self.SETTING["color-dim"] = __value_color_dim
		self.SETTING["color-highlight"] = __value_color_highlight
		self.SETTING["color-cursor"] = __value_color_cursor

		self.xml.get_widget("colorbutton6").set_color( \
			func.str_to_color(__value_color_foreground, "black"))
		self.xml.get_widget("colorbutton7").set_color( \
			func.str_to_color(__value_color_background, "white"))
		self.xml.get_widget("colorbutton8").set_color( \
			func.str_to_color(__value_color_dim, "green"))
		self.xml.get_widget("colorbutton9").set_color( \
			func.str_to_color(__value_color_highlight, "blue"))
		self.xml.get_widget("colorbutton10").set_color( \
			func.str_to_color(__value_color_cursor, "red"))

		# max scroll line
		__default_max_scroll_line =\
			self.GCONF_CLIENT.get_value_by_conf("max-scrollline")
		__value_max_scroll_line =\
			self.__get_value_from_data("max-scroll-line", __default_max_scroll_line)

		self.SETTING["max-scroll-line"] = __value_max_scroll_line

		try :
			__value_max_scroll_line = int(__value_max_scroll_line)
		except ValueError :
			__value_max_scroll_line = __default_max_scroll_line

		self.xml.get_widget("spinbutton3").set_value(__value_max_scroll_line)

		# connecting signals.
		__colorbutton_foreground = self.xml.get_widget("colorbutton6")
		__colorbutton_foreground.connect( \
			"color-set", self.on_color_changed, "foreground")

		__colorbutton_background = self.xml.get_widget("colorbutton7")
		__colorbutton_background.connect( \
			"color-set", self.on_color_changed, "background")

		__colorbutton_dim = self.xml.get_widget("colorbutton8")
		__colorbutton_dim.connect( \
			"color-set", self.on_color_changed, "dim")

		__colorbutton_highlight = self.xml.get_widget("colorbutton9")
		__colorbutton_highlight.connect( \
			"color-set", self.on_color_changed, "highlight")

		__colorbutton_cursor = self.xml.get_widget("colorbutton10")
		__colorbutton_cursor.connect( \
			"color-set", self.on_color_changed, "cursor")

		###########################################################################33
		# set Effect section

		# set background type.
		self.RADIOBUTTON_NONE = self.xml.get_widget("radiobutton7")
		self.RADIOBUTTON_IMAGE = self.xml.get_widget("radiobutton8")
		self.RADIOBUTTON_TRANS = self.xml.get_widget("radiobutton9")

		self.RADIOBUTTON_NONE.connect("toggled", self.on_change_background_type, "None")
		self.RADIOBUTTON_IMAGE.connect("toggled", self.on_change_background_type, "image-file")
		self.RADIOBUTTON_TRANS.connect("toggled", self.on_change_background_type, "transparent")

		__background_type = self.__get_value_from_data("vte-background-type", "None")

		if __background_type == "transparent" :
			self.RADIOBUTTON_TRANS.set_active(True)
		elif __background_type == "image-file" :
			__image_file = \
				self.__get_value_from_data("vte-background-image-file", None)

			if os.path.isfile(__image_file) :
				self.RADIOBUTTON_IMAGE.set_active(True)
				self.xml.get_widget("entry21").set_text(__image_file)
			else :
				self.RADIOBUTTON_NONE.set_active(True)
		else :
			self.RADIOBUTTON_NONE.set_active(True)

		# set shade when transparent background
		__scale_shade = self.__get_value_from_data("vte-background-shade", 0.0)

		if __scale_shade < 0 or __scale_shade > 1 : __scale_shade = 0.0
		self.xml.get_widget("hscale2").set_value(__scale_shade)

		self.__save_setting()

	def on_change_background_image_file (self, widget) :
		__value = self.xml.get_widget("entry21").get_text()
		self.SETTING["vte-background-image-file"] = __value

	def on_change_saturation (self, widget) :
		__value = round(widget.get_value(), 1)
		self.SETTING["vte-background-shade"] = __value

	def on_change_background_type (self, widget, type) :
		self.SETTING["vte-background-type"] = type

	def __save_setting (self) :
		return self.BOOKMARKS.save_setting( \
			self.DATA["__uid__"], self.SETTING)

	def __get_value_from_data \
			(self, key, defaultValue=None, allowNull=False) :
		if not self.SETTING.has_key(key) :
			return defaultValue
		else :
			if not allowNull and not self.SETTING[key] :
				return defaultValue

			return self.SETTING[key]

	def on_set_default_command (self, widget) :
		if self.DATA["type"] == "vim" :
			__default = \
				self.GCONF_CLIENT.get_value_by_conf("command-vim")
		elif self.DATA["type"] == "gvim" :
			__default = \
				self.GCONF_CLIENT.get_value_by_conf("command-gvim")
		elif self.DATA["type"] == "terminal" :
			__default = \
				self.GCONF_CLIENT.get_value_by_conf("command-terminal")
		elif self.DATA["type"] == "external_command" :
			__default = self.DATA["value"]
		else :
			__value_command = ""

		self.xml.get_widget("combo-entry1").set_text(__default)

	def on_set_default_color (self, widget) :
		__default_color_foreground =\
			self.GCONF_CLIENT.get_value_by_conf("color-foreground")
		__default_color_background =\
			self.GCONF_CLIENT.get_value_by_conf("color-background")
		__default_color_dim =\
			self.GCONF_CLIENT.get_value_by_conf("color-dim")
		__default_color_highlight =\
			self.GCONF_CLIENT.get_value_by_conf("color-highlight")
		__default_color_cursor =\
			self.GCONF_CLIENT.get_value_by_conf("color-cursor")

		self.xml.get_widget("colorbutton6").set_color( \
			func.str_to_color(__default_color_foreground, "black"))
		self.xml.get_widget("colorbutton7").set_color( \
			func.str_to_color(__default_color_background, "white"))
		self.xml.get_widget("colorbutton8").set_color( \
			func.str_to_color(__default_color_dim, "green"))
		self.xml.get_widget("colorbutton9").set_color( \
			func.str_to_color(__default_color_highlight, "blue"))
		self.xml.get_widget("colorbutton10").set_color( \
			func.str_to_color(__default_color_cursor, "red"))

	def on_set_default_font (self, widget) :
		# font
		__default_use_system_default_font = \
			self.GCONF_CLIENT.get_value_by_conf("use-system-default-font")
		__default_font = \
			self.GCONF_CLIENT.get_value_by_conf("font")

		self.xml.get_widget("checkbutton22").set_active( \
			__default_use_system_default_font)

		WIDGET_FONT = self.xml.get_widget("fontbutton5")
		WIDGET_FONT.set_font_name(__default_font)

		WIDGET_FONT.set_property("sensitive", \
			not __default_use_system_default_font)

	def on_set_default_etc (self, widget) :
		__default_max_scroll_line =\
			self.GCONF_CLIENT.get_value_by_conf("max-scrollline")
		self.xml.get_widget("spinbutton3").set_value(__default_max_scroll_line)

	def on_apply (self, widget) :
		self.__save_setting()

	def on_ok (self, widget) :
		self.__save_setting()
		self.on_close(widget)

	def on_change_labelname (self, widget) :
		new_label = widget.get_text()
		self.DATA["label"] = new_label
		self.STATE.get_value("bookmark-treestore")[self.PATH][0] = new_label

	def on_change_target (self, widget) :
		new_target = widget.get_text()
		self.DATA["value"] = new_target

	def on_change_command (self, widget) :
		self.SETTING["command"] = widget.get_text()

	def on_color_changed (self, widget, type) :
		__c = func.color_to_str(widget.get_color())
		self.SETTING["color-%s" % type] = __c

	def on_font_set (self, widget) :
		self.SETTING["font"] = widget.get_font_name()

	def on_use_system_font (self, widget) :
		WIDGET_FONT = self.xml.get_widget("fontbutton5")

		if not widget.get_active() :
			WIDGET_FONT.set_property("sensitive", True)
		else :
			WIDGET_FONT.set_property("sensitive", False)

		self.SETTING["use-system-default-font"] = widget.get_active()

	def on_change_max_scrollline (self, widget) :
		self.SETTING["max-scroll-line"] = widget.get_value()

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Window.py"

