# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, base64, marshal, gtk, gobject

import child, __BASIC__, __VTE__
import Conf, TAB, State, Label, func, i18n

_ = i18n.gettext()

class egg (__VTE__.egg) :

	CHILD_TYPE = child.TYPE_VIM
	FORK_COMMAND = "vim"
	INIT_COMMAND = [ \
		"\033:set title titlestring=%f;;;%t\n:\n\n",
		"\033:set mouse=nvi\n:\n\n",
	]

	FILENAME = str()

	def __init__ (self, **kwargs) :
		__VTE__.egg.__init__(self, **kwargs)

		if kwargs.has_key("filename") :
			self.FILENAME = kwargs["filename"]

	def make (self) :
		__VTE__.egg.make(self)

		# set initial command.
		for i in self.INIT_COMMAND :
			self.WIDGET.feed_child(i)

		if self.FILENAME :
			__dirname = os.path.dirname(self.FILENAME)

			"""
			chdir to this file's directory.
			"""
			self.WIDGET.feed_child("\033:cd %s\n" % \
				func.escape_path(__dirname) \
			)

			self.WIDGET.feed_child(":e %s\n" % \
				func.escape_path(self.FILENAME) \
			)

			self.store_recent()

	def fork_command (self) :
		__fork_command = self.SETTING.get_command_vim()

		__parsed_command = \
			func.parse_command_line_argument(__fork_command)

		self.ARGUMENT = __parsed_command["argument"]
		self.ENVIRONMENT = __parsed_command["environment"]
		self.FORK_COMMAND = __parsed_command["command"]

		__VTE__.egg.fork_command(self)

	def set_notify (self) :
		return

	def exit (self) :
		self.WIDGET.feed_child("\033:qa\n")

		__VTE__.egg.exit(self)

	def reset (self, parm1=None, parm2=None, parm3=None) :
		self.WIDGET.feed_child("\033\n")
		__VTE__.egg.reset(self, parm1, parm2, parm3)

	def activate_dnd (self) :
		pass

	def on_drag_received \
			(self, widget, context, x, y, selection, targetType, time) :
		pass

	def get_title (self) :
		__a = self.WIDGET.get_window_title()

		__b = __a.split(";;;")

		if len(__b) < 2 :
			__title = __a
		else :
			__dirname = os.path.dirname(func.normalize_path(__b[0]))
			if not os.path.isdir(__dirname) :
				__title = "".join(__b[1:])
			else :
				self.FILENAME = func.normalize_path(__b[0])

				# remember the last directory path.
				self.GCONF_CLIENT.set_value_by_conf( \
					"last-directory-path", \
					__dirname \
				)

				__title = __b[0]

		return __title

	def store_recent (self) :
		__data = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["recent-opened-files"]["key"])

		list_files = list()
		try :
			__data0 = base64.decodestring(__data)
			__data1 = marshal.loads(__data0)

			if type(__data1) is list :
				list_files = __data1
		except EOFError :
			pass

		if self.FILENAME in list_files :
			# remove old one and make new one be 1st.
			del(list_files[list_files.index(self.FILENAME)])

		list_files = [self.FILENAME,] + list_files

		__data = marshal.dumps(list_files)
		__data0 = base64.encodestring(__data)

		self.GCONF_CLIENT.set_value_by_conf( \
			"recent-opened-files", \
			__data0 \
		)

	def attach_popupmenu (self) : pass

class tab (__BASIC__.tab) :

	FILENAME = str()
	OPEN_IN_THIS_PAGE = False

	def __init__ (self, state, **kwargs) :

		__BASIC__.tab.__init__(self, state, **kwargs)

		if kwargs.has_key("filename") :
			#if os.path.exists(kwargs["filename"]) :
			#	self.FILENAME = kwargs["filename"]
			self.FILENAME = kwargs["filename"]

		if kwargs.has_key("openInThisPage") :
			self.OPEN_IN_THIS_PAGE = kwargs["openInThisPage"]

	def getEgg (self) :

		# get the latest directory path.
		if self.KWARGS.has_key("directory") :
			# remember the last directory path.
			self.GCONF_CLIENT.set_value_by_conf( \
				"last-directory-path", \
				self.KWARGS["directory"] \
			)
		else :
			__dirname = \
				self.GCONF_CLIENT.get_value(Conf.SCHEMA["last-directory-path"]["key"])
			if os.path.exists(__dirname) :
				self.KWARGS["directory"] = __dirname
			else :
				__dirname = os.getenv("HOME")

		self.EGG = egg(**self.KWARGS)
		self.EGG.make()

	def make (self) :

		self.getEgg()

		if not self.OPEN_IN_THIS_PAGE :
			self.WIDGET = TAB.One(state=self.STATE)

			if self.FILENAME : # add label
				__label = Label.TabWithCloseForVim( \
					filename=self.FILENAME, state=self.STATE)

				self.WIDGET.addLabel(__label)

			self.WIDGET.addVTE(self.EGG)

			self.append_tab()
		else :
			self.WIDGET = self.LIST_TAB[self.NOTEBOOK.get_current_page()]

			if self.WIDGET.Child.CHILD_TYPE != child.TYPE_VIM :
				self.WIDGET = TAB.One(state=self.STATE)

				__label = Label.TabWithCloseForVim( \
					filename=self.FILENAME, state=self.STATE)
				self.WIDGET.addLabel(__label)
				self.WIDGET.addVTE(self.EGG)

				self.append_tab()
			else :
				self.WIDGET.Child.WIDGET.feed_child(":e %s\n" % self.FILENAME)
				self.WIDGET.INSTANCE_LABEL.set_label(self.FILENAME)

		self.connect()

		self.WIDGET.Child.WIDGET.connect( \
			"drag_data_received", self.on_drag_received)

	def on_drag_received \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)

		__tab = tab(self.STATE, filename=__path)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "vim.py"

