# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, gettext as __gettext
import Conf__, Conf, func

def gettext () :
	try :
		t = __gettext.translation("vee", Conf__.DIR_LOCALE)
	except IOError :
		return __gettext.gettext
	else :
		return t.ugettext

def getDirectoryLocale (localedir) :
	# get locale environment value.

	envvars = ("LC_ALL", "LANG", "LC_MESSAGES", )

	for i in envvars :
		__v = os.getenv(i)

		if __v :
			envLocale = __v
			break

	langlist = __gettext._expand_lang(envLocale)
	for lang in langlist :
		if lang == "C" : return None

		__dir = os.path.join(localedir, lang)
		if os.path.exists(__dir) and os.path.isdir(__dir) :
			return __dir

	return None

####################################################################33
# label name
_ = gettext()

LABEL_EXTERNAL_COMMAND = { \
	"label96" : _("Saved commands."), \
	"label97" : _("Add"), \
	"label98" : _("Remove"), \
}

LABEL_PREFERENCES = { \
	"checkbutton13" : _("Show menubar"), \
	"checkbutton14" : _("Show toolbar"), \
	"checkbutton18" : _("Show statusbar"), \
	"checkbutton15" : _("Show bookmark"), \
	"checkbutton12" : _("Use gnome default monospace font."), \
	"label75" : _("Default Font :"), \
	"label51" : _("Main"), \
	"label59" : _("Command"), \
	"label88" : _("<span>Terminal</span>"), \
	"label77" : _("VIM Command"), \
	"label78" : _("Terminal Command"), \
	"label91" : _("GVIM Command"), \
	"label50" : _("<b>Main</b>"), \
	"label58" : _("<b>Command</b>"), \
	"label89" : _("Maximum line number to scroll :"), \
	"label104" : _("Foreground"), \
	"label105" : _("Background"), \
	"label106" : _("Dim"), \
	"label107" : _("Highlight"), \
	"label108" : _("Cursor"), \
	"label111" : _("Fonts"), \
	"label103" : _("<b>Colors</b>"), \
	"label113" : _("Colors"), \
	"label216" : _("Keyboard Shortcut"), \
	"label115" : _("<b>Layout</b>"), \
	"label116" : _("Tab position"), \
	"label121" : _("* You need to restart VEE."), \
	"label180" : _("Initially start this module"), \
	"label182" : _("<b>Start Up</b>"), \
	"checkbutton19" : _("Not Use?"), \
	"checkbutton20" : _("Not Use?"), \
	"checkbutton21" : _("Not Use?"), \
	"label202" : _("Effect"), \
	"label205" : _("Image file : "), \
	"label214" : _("CAUTION"), \
	"label197" : _("<b>Background</b>"), \
	"label201" : _("Shade transparent or image background :"), \
	"label203" : _("<i>None</i>"), \
	"label204" : _("<i>Maximum</i>"), \
	"label215" : _("\"Transparent background\" spends much system resource, so you want vee to play lightly, do use \"None\""), \
	"radiobutton4" : _("None (Use background color)"), \
	"radiobutton5" : _("Background image"), \
	"radiobutton6" : _("Transparent background"), \
	"label217" : _("To edit a shortcut key, click on the corresponding row and type a new accelerator, or press backspace to clear."), \
 
}

LABEL_BOOKMARK_SETTING = { \
	"label152" : _("General"), \
	"label153" : _("Fonts"), \
	"label154" : _("Colors"), \
	"checkbutton22" : _("Use Gnome Default Terminal Fonts."), \
	"label125" : _("Use This Font :"), \
	"label129" : _("Foreground"), \
	"label130" : _("Background"), \
	"label131" : _("Dim"), \
	"label132" : _("Highlight"), \
	"label133" : _("Cursor"), \
	"label155" : _("Effect"), \
	"label206" : _("Etc"), \
	"label122" : _("<b>Terminal</b>"), \
	"label123" : _("Maximum line number to scroll :"), \
	"label147" : _("<b>Info</b>"), \
	"label138" : _("Label Name"), \
	"label139" : _("Target"), \
	"label146" : _("<b>Command</b>"), \
	"label124" : _("<b>Fonts</b>"), \
	"label124" : _("<b>Fonts</b>"), \
	"button3" : _("Set Default"), \
	"button5" : _("Set Default"), \
	"button6" : _("Set Default"), \
	"button7" : _("Set Default"), \
	"label207" : _("Image file : "), \
	"label212" : _("CAUTION"), \
	"label211" : _("<b>Background</b>"), \
	"label208" : _("Shade transparent or image background :"), \
	"label209" : _("<i>None</i>"), \
	"label210" : _("<i>Maximum</i>"), \
	"label213" : _("\"Transparent background\" spends much system resource, so you want vee to play lightly, do use \"None\""), \
	"radiobutton7" : _("None (Use background color)"), \
	"radiobutton8" : _("Background image"), \
	"radiobutton9" : _("Transparent background"), \

}

LABEL_MAIN_MENU = { \
	"file1" : _("File"), \
	"Open" : _("_Open (Alt+Shift+F)"), \
	"NewVIM" : _("_New VIM (Ctrl+Alt+V)"), \
	"new_gvim1" : _("New _GVIM (Ctrl+Alt+G)"), \
	"NewTerminal" : _("_New Terminal (Ctrl+Alt+Z)"), \
	"quit" : _("_Quit (Ctrl+Q)"), \
	#"edit1" : _("Edit"), \
	#"edit_profiles1" : _("Edit profiles"), \
	"view2" : _("_View"), \
	"show_menubar1" : _("Show/hide menubar"), \
	"show_toolbar1" : _("Show/hide toolbar"), \
	"show_bookmark1" : _("Show/hide bookmark"), \
	"show_statusbar1" : _("Show/hide statusbar"), \
	"previous_tab1" : _("Previous tab (Ctrl+Shift+PgDn)"), \
	"next_tab1" : _("Next Tab (Ctrl+Shift+PgUp)"), \
	"increase_fonts2" : _("_Increase fonts (Ctrl+=)"), \
	"decrease_fonts2" : _("_Decrease fonts (Ctrl+-)"), \
	"preferences1" : _("Preferences"), \
	"contents1" : _("_Contents"), \
	"keyboard_shortcut1" : _("_Keyboard Shortcut"), \
	"bookmark2" : _("Bookmark"), \
	"help1" : _("Help"), \
	"about1" : _("About"), \
}

LABEL_FILE_CHOOSER = { \
	"label109" : _("Recent Opened Files are,"), \
	"label110" : _("Recent Opened Directories are,"), \
	"label94" : _("Select Files"), \
	"label95" : _("Select Directory"), \
	"label176" : _("File Location"), \
	"label178" : _("File Location"), \
	"checkbutton16" : _("Open this _file(s) in current tab."), \
}

LABEL_ASKCLOSEALLTABDIALOG = { \
	"label87" : _("Quit VEE.\nAll the opened tab will be closed."), \
}

LABEL_MENU_VTE = { \
	"input_methods2" : _("Input Methods"), \
}

LABEL_MENU_TERMINAL = { \
	"input_methods1" : _("Input Methods"), \
	"select_directory_up" : _("Select Directory, UP"), \
	"select_directory_under" : _("Select Directory, Under"), \
}

LABEL_MENU_FULL = { \
	"new_vim1" : _("New _VIM"), \
	"new_gvim2" : _("New _GVIM"), \
	"new_terminal1" : _("New _Terminal"), \
	"run_command1" : _("Run _Command"), \
	"open_file(s)1" : _("Open _File(s)"), \
	"show_menubar" : _("Show menubar"), \
	"show_toolbar" : _("Show toolbar"), \
	"show_statusbar" : _("Show statusbar"), \
	"show_bookmark" : _("Show bookmark"), \
	"preferences2" : _("Preferences"), \
	"bookmark1" : _("Bookmark"), \
	"toggle1" : _("Toggle"), \
	"quit1" : _("Quit"), \
}

LABEL_MENU_BOOKMARK = { \
	"add_current1" : _("Add Current"),
	"new_category1" : _("New Category"),
	"rename1" : _("Rename"),
	"delete1" : _("Delete"),
	"property1" : _("Property"),
}

LABEL_BOOKMARKITEMTYPE = { \
	"vim1" : (_("VIM"),
		func.create_icon( \
			os.path.join(Conf__.DIR_PIXMAPS, "vim.png")),),
	"gvim1" : (_("GVIM"),
		func.create_icon( \
			os.path.join(Conf__.DIR_PIXMAPS, "gvim.png")),),
	"terminal1" : (_("Terminal"),
		func.create_icon( \
			os.path.join(Conf__.DIR_PIXMAPS, "terminal.png")),),
	"external_command1" : (_("External Command"),
		func.create_icon( \
			os.path.join(Conf__.DIR_PIXMAPS, "external-command.png")),),
}

LABEL_MAIN_WINDOW = { \
	"toolbutton12" : _("GVIM"), \
	"toolbutton1" : _("VIM"), \
	"toolbutton5" : _("Open File"), \
	"toolbutton8" : _("Terminal"), \
	"toolbutton9" : _("Next Tab"), \
	"toolbutton10" : _("Previous Tab"), \
	"toolbutton14" : _("Run Command"), \
	"label93" : _("Show Bookmark Panel (Ctrl+Alt+B)"), \
}

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "i18n.py"


