#!/usr/bin/env python
# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import sys, os
"""
for testing of VTE python module.
"""
__path_vte_module = "/usr/local/lib/vte/default/lib/python2.3/site-packages/gtk-2.0"

if os.path.isdir(__path_vte_module) :
	sys.path = [__path_vte_module,] + sys.path

import pygtk
pygtk.require("2.0")

import i18n
_ = i18n.gettext()

try :
	import gtk
except :
	print _("You need to install pygtk or GTKv2.")
	sys.exit(1)

import Window, Options, GConf, func

if __name__ == "__main__" :

	# parse command-line argument.
	__parser = Options.VEE()
	(__OPTIONS, __ARGS) = __parser.parse_args()

	# check options and print error.
	if __OPTIONS.ARG_GEOMETRY :
		if not func.parse_geometry(__OPTIONS.ARG_GEOMETRY) :
			__parser.error(_("Invalid '--geometry' value, %s") % __OPTIONS.ARG_GEOMETRY)

	# check whether the gconf schema was installed, if not install it.
	if __OPTIONS.ARG_INSTALL_SCHEMA :
		if GConf.install_schema() :
			sys.exit(0)
		else :
			sys.exit(1)
	else :
		GConf.verify()

	app = Window.VEE(args_options=__OPTIONS, args_args=__ARGS)

	try :
		gtk.main()
	except :
		sys.exit(1)
	else :
		sys.exit(0)

